/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package visuAnalor.Apprentissage;

/**
 *
 * @author Bernard
 */
public class CalculApprentissage extends Thread {
  private boolean stop;
  private Evaluateur evalue;
  private VisuApprentissage visu;
  CalculApprentissage(Evaluateur evalue, VisuApprentissage visu) {
    this.evalue = evalue;
    this.visu = visu;
    stop = false;
  }

  interface Evaluateur {
    double[] evaluer(double[] vals);
    double[] getVals();   // passe les valeurs courantes par pointeur 
    double[] getPerfs();  // passe les performances courantes par pointeur
    void demarrerReprendre(); 
    void stopper();
    void appliquer();

  }
  void stopper() {
    stop = true;
  }
  @Override
  public void run() {
    int nbechecs = 0;
    double delta = 0.4;
    double deltamin = 0.01;
    int nbvals = evalue.getVals().length;
    int nbmaxechecs = (int) Math.floor(Math.pow(4, nbvals));
    double[] vals1 = new double[nbvals];
    double[] perfs1 = new double[3];
    visu.affFmesure(evalue.getPerfs()[2]);
    while (true) {
      visu.setValsCourantes(evalue.getVals(), evalue.getPerfs());
      if (stop) break;
      for (int i = 0; i<nbvals; i++)
        vals1[i] = evalue.getVals()[i]*(1+delta*(2*Math.random()-1));
      perfs1 = evalue.evaluer(vals1);
      visu.affFmesure(perfs1[2]);
      if (perfs1[2]>evalue.getPerfs()[2]) {
        System.arraycopy(vals1, 0, evalue.getVals(), 0, nbvals);
        System.arraycopy(perfs1, 0, evalue.getPerfs(), 0, 3);
        nbechecs = 0;
        continue;
      }
      if (++nbechecs<nbmaxechecs) continue;
      if ((delta /= 2)>deltamin) {
        nbechecs = 0;
        continue;
      }
      break;
    }
    visu.arreter();
    return;
  }
}
