/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package visuAnalor.Apprentissage;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import org.jfree.chart.*;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.plot.*;
import org.jfree.chart.renderer.xy.DefaultXYItemRenderer;
import org.jfree.data.*;
import org.jfree.data.general.*;
import org.jfree.data.xy.*;
import visuAnalor.util.*;
import visuAnalor.util.GMessages.*;

/**
 *
 * @author Bernard
 */
public class VisuApprentissage extends JFrame {
  private CalculApprentissage.Evaluateur apprend;
  private XYPlot plot;
  private DonneesPts data;
  private JButton demarre, arrete, annule, applique;
  private JLabel affNbExemples;
  private JLabel[] affvals, affvalsInit, affperfs, affperfsInit;
  private float[] formats;
  VisuApprentissage(Frame fenetre, CalculApprentissage.Evaluateur apprend,
          String titre, String[][] labels, float[] formats) {
    super(titre);
    this.apprend = apprend;
    this.formats = formats;
    Point pos = new Point(fenetre.getX()+50, fenetre.getY()+100);
    Dimension dim = new Dimension(Math.max(200, fenetre.getWidth()-100),
            fenetre.getHeight()-200);
    setLocation(pos);
    setSize(dim);
    int nbVariables = labels.length;
    data = new DonneesPts(nbVariables);
    Box cadre = Box.createVerticalBox();
    setContentPane(cadre);
    NumberAxis axeX = new NumberAxis("Nombre d'essais");
    NumberAxis axeY = new NumberAxis("F-mesure");
    axeY.setAutoRangeIncludesZero(false);
    DefaultXYItemRenderer rendu = new DefaultXYItemRenderer();
    rendu.setBaseShapesVisible(false);
    rendu.setBaseLegendShape(null);
    plot = new XYPlot(data, axeX, axeY, rendu);
    //    plot.setDomainAxis(axeF0);
//    plot.setRangeAxis(axeFreq);
//    plot.setOrientation(PlotOrientation.HORIZONTAL);
//    plot.setRenderer(rendu);
//    rendu.setDrawBarOutline(true);
//    rendu.setAutoPopulateSeriesOutlinePaint(false);
//    rendu.setBaseOutlinePaint(Color.BLACK);
//    rendu.setShadowVisible(false);
//    rendu.setAutoPopulateSeriesFillPaint(false);
//    rendu.setSeriesPaint(0, Color.BLUE);
//    rendu.setBaseSeriesVisibleInLegend(false);
//    rendu.setBarPainter(new StandardXYBarPainter());
//    rendu.setMargin(0.1);
    JFreeChart chart = new JFreeChart(plot);
    ChartPanel graphique = new ChartPanel(chart);
    cadre.add(Box.createVerticalGlue());
    cadre.add(graphique);
    JPanel grille = new JPanel(new GridLayout(3, 0));
    grille.add(new JLabel());
    for (String[] label : labels) {
      grille.add(new JLabel(GVisu.styleNomChamp(label), SwingConstants.CENTER));
    }
    grille.add(new JLabel(GVisu.styleNomChamp(new String[]{
              "Performances (en %)", "Précision - Rappel - F-mesure"}),
            SwingConstants.CENTER));
    grille.add(new JLabel("Valeurs initiales", SwingConstants.CENTER));
    affvalsInit = new JLabel[nbVariables];
    for (int i = 0; i<affvalsInit.length; i++) {
      affvalsInit[i] = new JLabel("", SwingConstants.CENTER);
      grille.add(affvalsInit[i]);
    }
    Box bperfsinit = Box.createHorizontalBox();
    affperfsInit = new JLabel[3];
    for (int i = 0; i<3; i++) {
      affperfsInit[i] = new JLabel("", SwingConstants.CENTER);
      bperfsinit.add(Box.createHorizontalGlue());
      bperfsinit.add(affperfsInit[i]);
    }
    bperfsinit.add(Box.createHorizontalGlue());
    grille.add(bperfsinit);
    grille.add(new JLabel("Valeurs courantes", SwingConstants.CENTER));
    affvals = new JLabel[nbVariables];
    for (int i = 0; i<affvals.length; i++) {
      affvals[i] = new JLabel("", SwingConstants.CENTER);
      grille.add(affvals[i]);
    }
    Box bperfs = Box.createHorizontalBox();
    affperfs = new JLabel[3];
    for (int i = 0; i<3; i++) {
      affperfs[i] = new JLabel("", SwingConstants.CENTER);
      bperfs.add(Box.createHorizontalGlue());
      bperfs.add(affperfs[i]);
    }
    bperfs.add(Box.createHorizontalGlue());
    grille.add(bperfs);
    cadre.add(Box.createVerticalStrut(30));
    cadre.add(grille);
    affNbExemples = new JLabel("", SwingConstants.CENTER);
    demarre = new JButton(
            new GAction("Démarrer") {
              @Override
              public void executer() {
                demarrerReprendre();
              }
            ;
    });
        arrete = new JButton(
            new GAction("Arrêter") {
              @Override
              public void executer() {
                arreter();
              }
            });
    annule = new JButton(
            new GAction("Annuler") {
              @Override
              public void executer() {
                annuler();
              }
            });
    applique = new JButton(
            new GAction("Appliquer") {
              @Override
              public void executer() {
                appliquer();
              }
            });
    Box boutons = Box.createHorizontalBox();
    boutons.add(Box.createGlue());
    boutons.add(affNbExemples, Box.CENTER_ALIGNMENT);
    boutons.add(Box.createGlue());
    boutons.add(demarre, Box.CENTER_ALIGNMENT);
    boutons.add(Box.createHorizontalStrut(30));
    boutons.add(arrete, Box.CENTER_ALIGNMENT);
    boutons.add(Box.createGlue());
    boutons.add(annule, Box.CENTER_ALIGNMENT);
    boutons.add(Box.createHorizontalStrut(30));
    boutons.add(applique, Box.CENTER_ALIGNMENT);
    boutons.add(Box.createGlue());
    cadre.add(Box.createVerticalGlue());
    cadre.add(Box.createVerticalStrut(30));
    cadre.add(boutons);
    cadre.add(Box.createVerticalGlue());
    cadre.add(Box.createVerticalStrut(15));
    // Fermeture de la fenêtre
    setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    addWindowListener(new WindowAdapter() {
      @Override
      public void windowClosing(WindowEvent evt) {
        annuler();
      }
    });
    initBoutons();
  }
  void setNbExemples(int nb) {
    affNbExemples.setText("Corpus contenant " + nb + " exemples");
  }
  void setValsInitiales(double[] vals, double[] perfs) {
    for (int i = 0; i<vals.length; i++) {
      affvalsInit[i].setText(GVisu.styleValChamp(Float.toString(
              Math.round((float) vals[i]*formats[i])/100f)));
    }
    for (int i = 0; i<perfs.length; i++) {
      affperfsInit[i].setText(GVisu.styleValChamp(Float.toString(
              Math.round((float) perfs[i]*1000)/10f)));
    }
    data.init();
  }
  void setValsCourantes(double[] vals, double[] perfs) {
    for (int i = 0; i<vals.length; i++) {
      affvals[i].setText(GVisu.styleValChamp(Float.toString(
              Math.round((float) vals[i]*formats[i])/100f)));
    }
    for (int i = 0; i<perfs.length; i++) {
      affperfs[i].setText(GVisu.styleValChamp(Float.toString(
              Math.round((float) perfs[i]*1000)/10f)));

    }
  }
  void affFmesure(double fmesure) {
    data.add(fmesure);
  }
  private void initBoutons() {
    demarre.setEnabled(true);
    arrete.setEnabled(false);
    annule.setEnabled(true);
    applique.setEnabled(false);
  }
  private void demarrerReprendre() {
    demarre.setEnabled(false);
    arrete.setEnabled(true);
    annule.setEnabled(false);
    applique.setEnabled(false);
    apprend.demarrerReprendre();

  }
  void arreter() {
    apprend.stopper();
    demarre.setText("Reprendre");
    demarre.setEnabled(true);
    arrete.setEnabled(false);
    annule.setEnabled(true);
    applique.setEnabled(true);
  }
  private void annuler() {
    dispose();
  }
  private void appliquer() {
    dispose();
    apprend.appliquer();
  }

  private class DonneesPts extends AbstractSeriesDataset implements XYDataset {
    private ArrayList<Double> ys;
    private DonneesPts(int nbVariables) {
      super();
      ys = new ArrayList<Double>(10*(int) Math.floor(Math.pow(6, nbVariables)));
    }
    private void init() {
      ys.clear();
    }
    private void add(double y) {
      ys.add(y);
      fireDatasetChanged();
    }
    @Override
    public int getSeriesCount() {
      return 1;
    }
    @Override
    public Comparable getSeriesKey(int series) {
      if (series!=0) throw new IndexOutOfBoundsException();
      return "F-mesure";
    }
    @Override
    public DomainOrder getDomainOrder() {
      return DomainOrder.ASCENDING;
    }
    @Override
    public int getItemCount(int series) {
      return ys.size();
    }
    @Override
    public Number getX(int series, int item) {
      return new Double(item);
    }
    @Override
    public double getXValue(int series, int item) {
      return item;
    }
    @Override
    public Number getY(int series, int item) {
      return new Double(ys.get(item));
    }
    @Override
    public double getYValue(int series, int item) {
      return ys.get(item);
    }
  }
}