/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package visuAnalor;

import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import javax.swing.*;
import org.jfree.chart.annotations.*;
import org.jfree.chart.axis.*;
import org.jfree.chart.plot.*;
import org.jfree.chart.renderer.xy.*;
import org.jfree.data.xy.*;
import org.jfree.ui.*;
import visuAnalor.PanneauEditeur.*;
import visuAnalor.donnees.*;
import visuAnalor.util.GMessages.*;

/**
 *
 * @author Bernard
 */
public class BandeauFonctions extends XYPlot implements Bandeau {
  private PanneauEditeur editeur;
  private CourbeF0 f0;
  private CourbeIntensite I;
  private FonctionsRenderer renduf0, renduf0lissee, renduProsogramme;
  private XYBoxAnnotation zoneSelect;
  private XYLineAnnotation[] bornesTire;
  private ArrayList<XYLineAnnotation> coupuresPeriodes;
  private final static Shape POINT_F0 = new Ellipse2D.Double(-1, -1, 2, 2);
  private final static Stroke LIGNE_F0 = new BasicStroke(1.5f);
  private final static Stroke LIGNE_F0_LISSEE = new BasicStroke(4f);
  private final static Stroke LIGNE_PROSOGRAMME = new BasicStroke(5f);
  private final static Stroke LIGNE_INTENSITE = new BasicStroke(.5f);
  private final static Stroke COUPURE_PERIODE_SURE = new BasicStroke(1.5f);
  private final static Stroke COUPURE_PERIODE_DOUTE =
          new BasicStroke(1.5f, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER,
          10f, new float[]{10f, 5f}, 0f);
  private final static Stroke GRILLE_F0 = new BasicStroke(1f);
  private final static Paint COULEUR_F0 = new Color(0f, 0f, 0.5f);
  private final static Paint COULEUR_F0_SELECT = Color.RED;
  private final static Paint COULEUR_F0_LISSEE = new Color(0f, 0.5f, 0f);
  private final static Paint COULEUR_PROSOGRAMME = new Color(1f, 0f, 0f, 1f);
  private final static Paint COULEUR_INTENSITE = new Color(0.3f, 0f, 0.3f);
  private final static Paint COULEUR_COUPURE_PERIODE = new Color(0f, 0.5f, 0f);
  private JPopupMenu popup;
  BandeauFonctions(PanneauEditeur editeur) {
    super();
    this.editeur = editeur;
    renduf0 = new FonctionsRenderer();
    setRenderer(renduf0);
    setSeriesRenderingOrder(SeriesRenderingOrder.FORWARD);
    renduf0lissee = new FonctionsRenderer();
    setRenderer(2, renduf0lissee);
    renduProsogramme = new FonctionsRenderer();
    setRenderer(3, renduProsogramme);
    setDatasetRenderingOrder(DatasetRenderingOrder.FORWARD);
    F0Axis axeF0 = new F0Axis();
    bornesTire = new XYLineAnnotation[0];
    coupuresPeriodes = new ArrayList<XYLineAnnotation>();
    setRangeAxis(axeF0);
    NumberAxis axeI = new NumberAxis("Intensité (en db)");
    axeI.setLabelPaint(COULEUR_INTENSITE);
    axeI.setAutoRangeIncludesZero(false);
    setRangeAxis(1, axeI);
    setRangeAxisLocation(1, AxisLocation.TOP_OR_RIGHT);
    mapDatasetToRangeAxis(1, 1);
    XYLineAndShapeRenderer renduI = new XYLineAndShapeRenderer(true, false);
    renduI.setSeriesPaint(0, COULEUR_INTENSITE);
    renduI.setSeriesStroke(0, LIGNE_INTENSITE);
    renduI.setSeriesVisibleInLegend(0, false);
    setRenderer(1, renduI);
    setDomainGridlinesVisible(false);
    effacerF0();
    effacerI();
    initPopup();
  }
  private void initPopup() {
    popup = new JPopupMenu();
    popup.add(new GAction("Supprimer la sélection") {
      @Override
      public void executer() {
        f0.supprimerSelection();
      }
    });
    popup.add(new GAction("Monter d'une octave") {
      @Override
      public void executer() {
        f0.deplacerSelection(1);
      }
    });
    popup.add(new GAction("Descendre d'une octave") {
      @Override
      public void executer() {
        f0.deplacerSelection(-1);
      }
    });
  }
  void newF0(CourbeF0 f0) {
    this.f0 = f0;
    if (f0!=null) {
      afficherF0();
    } else effacerF0();
  }
  void afficherF0() {
    setDataset(f0.getDataSet());
    F0Axis axeF0 = (F0Axis) getRangeAxis();
    if (!axeF0.isVisible()) {
      renduf0.init(f0);
      configurerAxeF0();
    }
  }
  private void effacerF0() {
    setDataset(null);
    setDataset(3, null);
    if (getDataset(2)==null) {
      F0Axis axeF0 = (F0Axis) getRangeAxis();
      axeF0.effacerTicks();
      setDomainGridlinesVisible(false);
      axeF0.setVisible(false);
      clearAnnotations();
    }
  }
  void effAffF0() {
    if (f0==null) return;
    if (getDataset()==null) afficherF0();
    else effacerF0();
  }
  void newIntensite(CourbeIntensite I) {
    this.I = I;
    if (I!=null) afficherI();
    else effacerI();
  }
  private void afficherI() {
    setDataset(1, I.getDataSet());
    getRangeAxis(1).setVisible(true);
  }
  private void effacerI() {
    setDataset(1, null);
    getRangeAxis(1).setVisible(false);
  }
  void effAffI() {
    if (I==null) return;
    if (getDataset(1)==null) afficherI();
    else effacerI();
  }
  void afficherLissage(CourbeF0 f0lissee) {
    setDataset(2, f0lissee.getDataSet());
    renduf0lissee.initLissee(f0lissee);
    if (getDataset()==null) afficherF0();
  }
  void effacerLissage() {
    setDataset(2, null);
    if (getDataset()==null) effacerF0();
  }
  void effacerProsogramme() {
    setDataset(3, null);
    if (getDataset()==null) effacerF0();
  }
  void afficherProsogramme(Prosogramme prosogramme) {
    setDataset(3, prosogramme.getDataSet());
    renduProsogramme.initProsogramme(prosogramme);
    if (getDataset()==null) afficherF0();
  }
  double[][] getProsogramme() {
    XYDataset data = getDataset(3);
    if (data==null) return null;
    double[][] proso = new double[2][data.getItemCount(0)];
    for (int i = 0; i<data.getItemCount(0); i++) {
      proso[0][i] = data.getXValue(0, i);
      proso[1][i] = data.getYValue(0, i);
    }
    return proso;
  }
  void afficherPeriodes(double[] coupes, int[] decisions) {
    for (XYLineAnnotation coupure : coupuresPeriodes) removeAnnotation(coupure);
    coupuresPeriodes.clear();
    Stroke ligne = null;
    for (int i = 0; i<coupes.length; i++) {
      if (decisions[i]==0) continue;
      ligne = decisions[i]==1 ? COUPURE_PERIODE_DOUTE : COUPURE_PERIODE_SURE;
      XYLineAnnotation coupure = new XYLineAnnotation(coupes[i], MIN_LOG_F0,
              coupes[i], MAX_LOG_F0, ligne, COULEUR_COUPURE_PERIODE);
      addAnnotation(coupure);
      coupuresPeriodes.add(coupure);
    }
  }
  void effacerPeriodes() {
    for (XYLineAnnotation coupure : coupuresPeriodes) removeAnnotation(coupure);
    coupuresPeriodes.clear();
  }
  void dessinerSelectionEnCours(double x1, double x2) {
    if (f0==null) return;
    if (zoneSelect!=null) removeAnnotation(zoneSelect);
    zoneSelect = new XYBoxAnnotation(Math.min(x1, x2),
            getRangeAxis().getLowerBound(),
            Math.max(x1, x2),
            getRangeAxis().getUpperBound());
    addAnnotation(zoneSelect);
  }
  @Override
  public void setSelection(double[] tSelects) {
    if (f0==null) return;
    if (zoneSelect!=null) removeAnnotation(zoneSelect);
    f0.selectionner(tSelects[0], tSelects[1]);
  }
  @Override
  public double[] getTSelects() {
    if (f0==null) return null;
    return f0.getTSelects();
  }
  void afficherSelectionPortion(double x) {
    f0.selectionnerPortionContenantunPoint(x);
  }
  void chercherSelectionPortion(double x, double y) {
    if (f0==null) return;
    f0.trouverSelectionnerPortion(x, y);
  }
  @Override
  public void effacerSelection() {
    if (f0==null) return;
    f0.deselectionner();
  }
  JPopupMenu getPopup() {
    if (getTSelects()==null) return null;
    return popup;
  }
  private void configurerAxeF0() {
    F0Axis axeF0 = (F0Axis) getRangeAxis();
    clearAnnotations();
    double[] bornes = f0.calculerBornesEtMoyenne();
    if (bornes==null) {
      effacerF0();
      return;
    }
    double borneinf = bornes[0];
    double bornesup = bornes[1];
    axeF0.setVisible(true);
    double moyenne = bornes[2];
    int inf = (int) Math.ceil((borneinf-moyenne)*12);
    int sup = (int) Math.ceil((bornesup-moyenne)*12);
    axeF0.setLowerBound(moyenne+(inf-2)/12.);
    axeF0.setUpperBound(moyenne+(sup+1)/12.);
    axeF0.configurerTicks(inf, sup, moyenne);
    setDomainGridlinesVisible(bornesTire.length==0);
    for (XYLineAnnotation borne : bornesTire) addAnnotation(borne);
    setRangeGridlineStroke(GRILLE_F0);
    double tinf = editeur.getTmin();
    double tsup = editeur.getTmax();
    for (int i = inf; i<sup; i++) {
      if (i%4!=0) continue;
      double f = moyenne+i/12.;
      addAnnotation(new XYLineAnnotation(tinf, f, tsup, f, GRILLE_F0,
              i==0 ? Color.BLUE : Color.BLACK));
    }

  }
  final static double MIN_LOG_F0 = 0;
  final static double MAX_LOG_F0 = 100;
  void afficherBornesTire(double[] bornes) {
    setDomainGridlinesVisible(false);
    for (XYLineAnnotation borne : bornesTire) removeAnnotation(borne);
    bornesTire = new XYLineAnnotation[bornes.length];
    for (int i = 0; i<bornes.length; i++) {
      bornesTire[i] = new XYLineAnnotation(bornes[i], MIN_LOG_F0, bornes[i],
              MAX_LOG_F0, GRILLE_F0, Color.BLACK);
      addAnnotation(bornesTire[i]);
    }
  }
  void effacerBornesTire() {
    setDomainGridlinesVisible(true);
    for (XYLineAnnotation borne : bornesTire) removeAnnotation(borne);
    bornesTire = new XYLineAnnotation[0];
  }

  private static class FonctionsRenderer extends XYLineAndShapeRenderer {
    private void init(CourbeF0 f0) {
      int nodatacourbe = f0.getNoDataF0();
      int nodataselection = f0.getNoDataF0Selection();
      setSeriesVisibleInLegend(nodatacourbe, false, false);
      setSeriesVisibleInLegend(nodataselection, false, false);
      setSeriesPaint(nodatacourbe, COULEUR_F0);
      setSeriesStroke(nodatacourbe, LIGNE_F0);
      setSeriesShape(nodatacourbe, POINT_F0);
      setSeriesPaint(nodataselection, COULEUR_F0_SELECT);
      setSeriesStroke(nodataselection, LIGNE_F0);
      setSeriesShape(nodataselection, POINT_F0);
    }
    private void initLissee(CourbeF0 f0lissee) {
      int nodatacourbe = f0lissee.getNoDataF0();
      int nodataselection = f0lissee.getNoDataF0Selection();
      setSeriesVisibleInLegend(nodatacourbe, false, false);
      setSeriesVisibleInLegend(nodataselection, false, false);
      setSeriesPaint(nodatacourbe, COULEUR_F0_LISSEE);
      setSeriesStroke(nodatacourbe, LIGNE_F0_LISSEE);
      setSeriesShapesVisible(nodatacourbe, false);
    }
    private void initProsogramme(Prosogramme prosogramme) {
      setSeriesVisibleInLegend(0, false, false);
      setSeriesPaint(0, COULEUR_PROSOGRAMME);
      setSeriesStroke(0, LIGNE_PROSOGRAMME);
      setSeriesShapesVisible(0, false);
    }
  }

  public static class F0Axis extends NumberAxis {
    final private double SEUIL_MINOR_TICKS = 6;
    boolean areTicksVisibles;
    int inf, sup;
    double moyenne;
    public F0Axis() {
      super("F0 (Hz)  [divisions : demi-tons]");
      setLabelPaint(COULEUR_F0);
    }
    public void effacerTicks() {
      areTicksVisibles = false;
    }
    public void configurerTicks(int inf, int sup, double moyenne) {
      this.inf = inf;
      this.sup = sup;
      this.moyenne = moyenne;
      areTicksVisibles = true;
    }
    @Override
    protected java.util.List refreshTicksVertical(Graphics2D g2,
            Rectangle2D dataArea, RectangleEdge edge) {
      java.util.List lticks = new ArrayList<NumberTick>();
      if (!areTicksVisibles) return lticks;
      boolean affminticks = dataArea.getHeight()/(sup-inf+1)>SEUIL_MINOR_TICKS;
      for (int i = inf-2; i<sup+2; i++) {
        if (i%4==0)
          lticks.add(new NumberTick(new Double(moyenne+i/12.),
                  String.valueOf(Math.round(Math.pow(2, moyenne+i/12.))),
                  TextAnchor.CENTER_RIGHT, TextAnchor.CENTER_RIGHT, 0));
        else if (affminticks)
          lticks.add(new NumberTick(new Double(moyenne+i/12.), "",
                  TextAnchor.CENTER_RIGHT, TextAnchor.CENTER_RIGHT, 0));
      }
      return lticks;
    }
  }
}
