/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package visuAnalor.analyses;

import java.util.*;
import visuAnalor.analyses.DetectionPeriodes.ValeurEuh;
import visuAnalor.donnees.*;

/**
 *
 * @author Bernard
 */
public class CalculsAnalyses {
  public static boolean[] reperer(String[] mots, String[] marques) {
    boolean[] trouves = new boolean[mots.length];
    for (int i = 0; i<trouves.length; i++) {
      for (String marque : marques) if (mots[i].equals(marque)) {
          trouves[i] = true;
          break;
        }
    }
    return trouves;
  }
  public static void joindre(CourbeF0 f0, double[] bornestirePauses,
          boolean[] isPause, double[] bornestireLoc) {
    // Suppression des points de f0 compris dans une pause
    int[][] indsasupprimer = trouverPtsDansIntervalles(f0.getPoints(),
            bornestirePauses, isPause);
    if (indsasupprimer.length>0) {
      f0.setPoints(supprimerPts(f0.getPoints(), indsasupprimer));
      f0.setCoupes(modifierCoupes(f0.getCoupes(), indsasupprimer));
    }
//     suppression des portions de f0 entièrement compris dans une pause
//    ArrayList<Integer> nosportionsasupprimer = trouverPortionsDansIntervalles(
//            f0.getPoints(), f0.getCoupes(), bornestirePauses, isPause);
//    if (!nosportionsasupprimer.isEmpty()) {
//      f0.setPoints(supprimerPtsPortions(f0.getPoints(), f0.getCoupes(),
//              nosportionsasupprimer));
//      f0.setCoupes(supprimerCoupesPortions(f0.getCoupes(), nosportionsasupprimer));
//    }
    // séparation en n+1 portions si n changements de locuteur dans une portion 
    ArrayList<Double> separations = trouverBornesDansPortions(f0.getPoints(),
            f0.getCoupes(), bornestireLoc);
    if (!separations.isEmpty()) {
      f0.setCoupes(separerPortions(f0.getPoints(), f0.getCoupes(), separations));
    }
    // réunion des portions non séparées par une pause ou un changement de locuteur
    ArrayList<Integer> noscoupesasupprimer = trouverCoupesSansIntervalle(f0.getPoints(),
            f0.getCoupes(), bornestirePauses, isPause);
    noscoupesasupprimer = oterNosCoupesAvecPoints(f0.getPoints(), f0.getCoupes(),
            noscoupesasupprimer, bornestireLoc);
    if (noscoupesasupprimer.isEmpty()) return;
    int nbptsinterpol[] = calculerNbPtsAAjouter(f0.getPoints(), f0.getDeltaT(), f0.getCoupes(),
            noscoupesasupprimer);
    f0.setPoints(reunirPtsPortions(f0.getPoints(), f0.getDeltaT(), f0.getCoupes(), noscoupesasupprimer,
            nbptsinterpol));
    f0.setCoupes(reunirCoupesPortions(f0.getCoupes(), noscoupesasupprimer, nbptsinterpol));
  }
 private static int[][] trouverPtsDansIntervalles(
          double[][] pts, double[] bornes, 
          boolean[] isIntervallePertinent) {
    // renvoie inds : tableau (n,2)
    // inds[i][0] est l'indice du premier pt du ième morceau trouvé
    // inds[i][1] est l'indice + 1 du dernier pt du ième morceau trouvé
    // Rappel : coupes.size() est égal au nombre de portions + 1.
    // coupes[i] est égal à l'indice du premier point de la portion n°i 
    //  et coupes[end] est égal à points[0].length.
    ArrayList<Integer> debs = new ArrayList<Integer>();
    ArrayList<Integer> fins = new ArrayList<Integer>();
    if (bornes.length<2) return new int[0][2];
    int indPts = 0;
    boucle:
    for (int indBorne = 0; indBorne<bornes.length-1; indBorne++) {
      if (!isIntervallePertinent[indBorne]) continue;
      double debInterv = bornes[indBorne];
      double finInterv = bornes[indBorne+1];
      while (pts[0][indPts]<debInterv) {
        indPts++;
        if (indPts==pts[0].length) break boucle;
      }
      debs.add(indPts);
      while (indPts<pts[0].length&&pts[0][indPts]<finInterv) indPts++;
      fins.add(indPts);
      if (indPts==pts[0].length) break boucle;
    }
    int[][] inds = new int[debs.size()][2];
    for (int i = 0; i<inds.length; i++) {
      inds[i][0] = debs.get(i);
      inds[i][1] = fins.get(i);
    }
    return inds;
  }
  private static double[][] supprimerPts(double[][] pts, int[][] indsasup) {
    // renvoie une nouvelle courbeF0 sans les morceaux donnés par indsasup
    int nbptsasupprimer = 0;
    for (int i = 0; i<indsasup.length; i++)
      nbptsasupprimer += indsasup[i][1]-indsasup[i][0];
    double[][] newpts = new double[2][pts[0].length-nbptsasupprimer];
    int indpts = 0, indnewpts = 0, nbacopier;
    for (int i = 0; i<indsasup.length; i++) {
      nbacopier = indsasup[i][0]-indpts;
      System.arraycopy(pts[0], indpts, newpts[0], indnewpts, nbacopier);
      System.arraycopy(pts[1], indpts, newpts[1], indnewpts, nbacopier);
      indnewpts += nbacopier;
      indpts = indsasup[i][1];
    }
    nbacopier = pts[0].length-indpts;
    System.arraycopy(pts[0], indpts, newpts[0], indnewpts, nbacopier);
    System.arraycopy(pts[1], indpts, newpts[1], indnewpts, nbacopier);
    return newpts;
  }
   private static ArrayList<Integer> modifierCoupes(
          ArrayList<Integer> coupes, int[][] indsasup) {
     // on met toutes les coupes potentielles en vrac puis on trie
     int[] newcoupes = new int[coupes.size()+2*indsasup.length];
     for(int i=0; i<coupes.size(); i++) newcoupes[i] = coupes.get(i);
     for(int i=0; i<indsasup.length; i++) {
       newcoupes[coupes.size()+2*i] = indsasup[i][0];
       newcoupes[coupes.size()+2*i+1] = indsasup[i][1];
     }
     Arrays.sort(newcoupes);
    // On rectifie new coupes en prenant en compte les décalages et les doublons
    int decalage = 0;
    int indSup = 0;
    ArrayList<Integer> newnewcoupes = new ArrayList<Integer>();
    newnewcoupes.add(0);
    for (int i = 1; i<newcoupes.length; i++) {
      int coupe = newcoupes[i];
      while (indSup<indsasup.length&&indsasup[indSup][1]<=coupe) {
        decalage += indsasup[indSup][1]-indsasup[indSup][0];
        indSup++;
      }
      if(indSup<indsasup.length&&indsasup[indSup][0]<coupe) 
        coupe = indsasup[indSup][0];
      if (newnewcoupes.get(newnewcoupes.size()-1)<coupe-decalage)
        newnewcoupes.add(coupe-decalage);
    }
    return newnewcoupes;
  }
  private static ArrayList<Double> trouverBornesDansPortions(
          double[][] pts, ArrayList<Integer> coupes, double[] bornes) {
    // bornesDedans contient t ssi la borne de valeur t est dans une portion  
    // Rappel : coupes.size() est égal au nombre de portions + 1.
    // coupes[i] est égal à l'indice du premier point de la portion n°i 
    //  et coupes[end] est égal à points[0].length.
    ArrayList<Double> bornesDedans = new ArrayList<Double>();
    if (bornes.length==0) return bornesDedans;
    int indBorne = 0;
    for (int c = 0; c<coupes.size()-1; c++) {
      int ideb = coupes.get(c);
      int ifin = coupes.get(c+1)-1;
      while (bornes[indBorne]<=pts[0][ideb]) {
        indBorne++;
        if (indBorne==bornes.length) return bornesDedans;
      }
      while (bornes[indBorne]<pts[0][ifin]) {
        bornesDedans.add(bornes[indBorne]);
        indBorne++;
        if (indBorne==bornes.length) return bornesDedans;
      }
    }
    return bornesDedans;
  }
  private static ArrayList<Integer> separerPortions(double[][] pts,
          ArrayList<Integer> coupes, ArrayList<Double> separations) {
    ArrayList<Integer> newcoupes = new ArrayList<Integer>();
    int indsep = 0;
    for (int c = 0; c<coupes.size()-1; c++) {
      newcoupes.add(coupes.get(c));
      int ideb = coupes.get(c);
      int ifin = coupes.get(c+1)-1;
      while (indsep<separations.size()&&separations.get(indsep)<pts[0][ifin]) {
        for (int i = ideb+1; i<ifin; i++)
          if (separations.get(indsep)<pts[0][i]) {
            newcoupes.add(i);
            break;
          }
        indsep++;
      }
    }
    newcoupes.add(coupes.get(coupes.size()-1));
    return newcoupes;
  }
  private static ArrayList<Integer> trouverCoupesSansIntervalle(
          double[][] pts, ArrayList<Integer> coupes, double[] bornesIntervalles,
          boolean[] isIntervallePertinent) {
    ArrayList<Integer> noscoupes = new ArrayList<Integer>();
    if (bornesIntervalles.length<2) {
      for (int i = 1; i<coupes.size()-1; i++) noscoupes.add(i);
      return noscoupes;
    }
    int indBorneSup = 1;
    for (int c = 1; c<coupes.size()-1; c++) {
      int ideb = coupes.get(c)-1;
      int ifin = coupes.get(c);
      while (bornesIntervalles[indBorneSup]<pts[0][ideb]) {
        indBorneSup++;
        if (indBorneSup==bornesIntervalles.length) {
          for (int i = c; i<coupes.size()-1; i++) noscoupes.add(i);
          return noscoupes;
        }
      }
      boolean aenlever = false;
      while (bornesIntervalles[indBorneSup-1]<=pts[0][ifin]) {
        if (isIntervallePertinent[indBorneSup-1]) {
          aenlever = true;
          break;
        }
        indBorneSup++;
        if (indBorneSup==bornesIntervalles.length) {
          for (int i = c; i<coupes.size()-1; i++) noscoupes.add(i);
          return noscoupes;
        }
      }
      if (!aenlever) noscoupes.add(c);
    }
    return noscoupes;

  }
  private static ArrayList<Integer> oterNosCoupesAvecPoints(double[][] pts,
          ArrayList<Integer> coupes, ArrayList<Integer> noscoupes, double[] bornes) {
    ArrayList<Integer> newnoscoupes = new ArrayList<Integer>();
    if (bornes.length==0) {
      for (int i = 0; i<noscoupes.size(); i++)
        newnoscoupes.add(noscoupes.get(i));
      return newnoscoupes;
    }
    int indBorne = 0;
    for (int no = 0; no<noscoupes.size(); no++) {
      int ifin = coupes.get(noscoupes.get(no));
      while (bornes[indBorne]<pts[0][ifin-1]) {
        indBorne++;
        if (indBorne==bornes.length) {
          for (int i = no; i<noscoupes.size()-1; i++)
            newnoscoupes.add(noscoupes.get(i));
          return newnoscoupes;
        }
      }
      if (bornes[indBorne]>pts[0][ifin]) newnoscoupes.add(noscoupes.get(no));
    }
    return newnoscoupes;
  }
  private static int[] calculerNbPtsAAjouter(double[][] pts, double delt,
          ArrayList<Integer> coupes, ArrayList<Integer> noscoupesasupprimer) {
    // calcul du nombre de points d'interpolation à ajouter pour chaque coupe à supprimer
    int[] nbptsinterp = new int[noscoupesasupprimer.size()];

    for (int no = 0; no<noscoupesasupprimer.size(); no++) {
      int ifin = coupes.get(noscoupesasupprimer.get(no));
      double taille = pts[0][ifin]-pts[0][ifin-1];
      nbptsinterp[no] = (int) Math.floor((taille/delt+0.1))-1;
    }
    return nbptsinterp;
  }
  private static double[][] reunirPtsPortions(double[][] pts, double delt,
          ArrayList<Integer> coupes, ArrayList<Integer> noscoupesasupprimer,
          int[] nbptsinterp) {
    // calcul du nouveau tableau pts
    int nbptsadd = 0;
    for (int no = 0; no<noscoupesasupprimer.size(); no++)
      nbptsadd += nbptsinterp[no];
    double[][] newpts = new double[2][pts[0].length+nbptsadd];
    int decalage = 0;
    int indpts = 0;
    for (int no = 0; no<noscoupesasupprimer.size(); no++) {
      int ifin = coupes.get(noscoupesasupprimer.get(no));
      System.arraycopy(pts[0], indpts, newpts[0], indpts+decalage, ifin-indpts);
      System.arraycopy(pts[1], indpts, newpts[1], indpts+decalage, ifin-indpts);
      indpts = ifin;
      for (int i = 0; i<nbptsinterp[no]; i++) {
        newpts[0][indpts+decalage+i] = pts[0][indpts-1]+(i+1)*delt;
        newpts[1][indpts+decalage+i] = pts[1][indpts-1]
                +(pts[1][indpts]-pts[1][indpts-1])*(i+1)/(nbptsinterp[no]+1);
      }
      decalage += nbptsinterp[no];
    }
    int ifin = coupes.get(coupes.size()-1);
    System.arraycopy(pts[0], indpts, newpts[0], indpts+decalage, ifin-indpts);
    System.arraycopy(pts[1], indpts, newpts[1], indpts+decalage, ifin-indpts);
    return newpts;
  }
  private static ArrayList<Integer> reunirCoupesPortions(
          ArrayList<Integer> coupes, ArrayList<Integer> noscoupesasupprimer,
          int[] nbptsinterp) {
    int no0 = 0;
    int decalage = 0;
    ArrayList<Integer> newcoupes = new ArrayList<Integer>();
    for (int no = 0; no<noscoupesasupprimer.size(); no++) {
      for (int no1 = no0; no1<noscoupesasupprimer.get(no); no1++)
        newcoupes.add(coupes.get(no1)+decalage);
      decalage += nbptsinterp[no];
      no0 = noscoupesasupprimer.get(no)+1;
    }
    for (int no1 = noscoupesasupprimer.get(noscoupesasupprimer.size()-1)+1;
            no1<coupes.size(); no1++)
      newcoupes.add(coupes.get(no1)+decalage);
    return newcoupes;
  }
  static void convoluer(CourbeF0 f0, double fenetre, double ecartmax) {
    int demifenetre = (Math.round((float) (fenetre/f0.getDeltaT())))/2;
    ArrayList<Integer> coupes = f0.getCoupes();
    for (int no = 0; no<coupes.size()-1; no++)
      f0.getPoints()[1] = convoluerPortion(f0.getPoints()[1],
              coupes.get(no), coupes.get(no+1),
              demifenetre, ecartmax);
  }
  private static double[] convoluerPortion(double[] f, int deb, int fin,
          int demifenetre, double ecartmax) {
    int nbpts = fin-deb;
    double[] f1 = new double[nbpts];
    int[] nbvoisins = new int[nbpts];
    for (int i = 0; i<nbvoisins.length; i++)
      nbvoisins[i] = Math.min(Math.min(i, nbpts-i-1), demifenetre);
    while (true) {
      double ecart = 0;
      int indmax = -1;
      for (int i = 0; i<nbpts; i++) {
        f1[i] = 0;
        for (int j = i-nbvoisins[i]; j<=i+nbvoisins[i]; j++) f1[i] += f[deb+j];
        f1[i] /= 2*nbvoisins[i]+1;
        double e = Math.abs(f[deb+i]-f1[i]);
        if (e>ecart) {
          ecart = e;
          indmax = i;
        }
      }
      if (ecart<=ecartmax) break;
      for (int i = 0; i<nbvoisins.length; i++)
        nbvoisins[i] = Math.min(Math.abs(i-indmax), nbvoisins[i]);
    }
    System.arraycopy(f1, 0, f, deb, nbpts);
    return f;
  }
  static double[] calculerBornesPeriode(double tdeb, double tfin, double deltaT,
          double[] bornesTirePauses, boolean[] isPause, double[] bornesLoc) {
    double bdeb = Double.NaN, bfin = Double.NaN;
    // On regarde d'abord s'il n'y a pas un cht de locuteur sans pause 
    // au debut et/ou à la fin du tronçon
    for (int i = 0; i<bornesLoc.length; i++) {
      double bLoc = bornesLoc[i];
      if (bLoc<tdeb-deltaT) continue;
      if (bLoc<=tdeb) bdeb = bLoc;
      if (bLoc<tfin) continue;
      if (bLoc<=tfin+deltaT) bfin = bLoc;
      break;
    }
    // Si bdeb n'est pas instancié, on cherche la pause qui précède 
    // ou qui contient tdeb
    if (Double.isNaN(bdeb)) {
      for (int i = 0; i<bornesTirePauses.length; i++) {
        if (bornesTirePauses[i]<tdeb) continue;
        for (int j = i; true; j--) if (j==0||isPause[j-1]) {
            bdeb = bornesTirePauses[j];
            break;
          }
        break;
      }
    }
    // Si bfin n'est pas instancié, on cherche la pause qui suit 
    // ou qui contient tfin
    if (Double.isNaN(bfin)) {
      for (int i = bornesTirePauses.length-1; i>=0; i--) {
        if (bornesTirePauses[i]>tfin) continue;
        for (int j = i; true; j++)
          if (j==bornesTirePauses.length-1||isPause[j]) {
            bfin = bornesTirePauses[j];
            break;
          }
        break;
      }
    }
    return new double[]{bdeb, bfin};
  }
  static double[][] extraireIntervallesPertinents(double[] bornesTire,
          boolean[] pertinents) {
    int nb = 0;
    for (boolean pertinent : pertinents) if (pertinent) nb++;
    double[][] intervallesPertinents = new double[2][nb];
    for (int i = 0, k = 0; i<pertinents.length; i++) if (pertinents[i]) {
        intervallesPertinents[0][k] = bornesTire[i];
        intervallesPertinents[1][k++] = bornesTire[i+1];
      }
    return intervallesPertinents;
  }
  static double[] fusionTri(double[]... bornes) {
    int nb = 0;
    for (double[] b : bornes) nb += b.length;
    double[] fusion = new double[nb];
    nb = 0;
    for (double[] b : bornes) {
      System.arraycopy(b, 0, fusion, nb, b.length);
      nb += b.length;
    }
    Arrays.sort(fusion);
    return fusion;
  }
  static int trouverIndiceIntervalle(double x, double[][] intervalles) {
    for (int j = 0; j<intervalles[0].length; j++) {
      if (x>intervalles[1][j]) continue;
      if (x>=intervalles[0][j]) return j;
      break;
    }
    return -1;
  }
  static double trouverMaxAvant(double x, double[] bornes) {
    for (int i = 1; i<bornes.length; i++) if (x<bornes[i]) return bornes[i-1];
    return bornes[bornes.length-1];
  }
  static double trouverMinApres(double x, double[] bornes) {
    for (int i = bornes.length-2; i>=0; i--) if (x>bornes[i])
        return bornes[i+1];
    return bornes[0];
  }
  public static int trouverBorneDansIntervalle(double[] bornes, double deb, double fin) {
    for (int i = 0; i<bornes.length; i++) {
      if (bornes[i]<deb) continue;
      if (bornes[i]<=fin) return i;
      break;
    }
    return -1;
  }
  static double calculerFqMaxFinal(double[][] points, int deb, int fin,
          double distanceMaximum) {
    for (int i = fin-1; i>=deb; i--) {
      if (points[0][fin]-points[0][i]>distanceMaximum) break;
      if (points[1][i]<points[1][i+1]) return points[1][i+1];
    }
    return points[1][fin];
  }
  static double calculerHausse(double[][] points, int indfdeb, double xmax) {
    double ydeb = points[1][indfdeb];
    double yfin = ydeb;
    for (int i = indfdeb+1; i<points[0].length; i++) {
      if (points[0][i]<=xmax) continue;
      yfin = points[1][i-1];
      break;
    }
    return yfin-ydeb;

  }
  static double calculerMoyenne(double[][] pts, int deb, int fin) {
    // fin non compris
    double res = 0;
    for (int i = deb; i<fin; i++) res += pts[1][i];
    return res/(fin-deb);
  }
  static boolean calculerDescente(double[][] pts, int deb, int fin) {
    // fin non compris
    for (int i = deb+1; i<fin; i++) if (pts[1][i]>pts[1][i-1]) return false;
    return true;
  }
  static double calculerMontee(double[][] pts, int deb, int fin) {
    // fin non compris
    double max = pts[1][deb];
    for (int i = deb+1; i<fin; i++) if (max<pts[1][i]) max = pts[1][i];
    return max-pts[1][deb];
  }
}
