/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package visuAnalor.donnees;

import java.util.*;
import javax.swing.table.*;
import org.jfree.data.xy.*;

/**
 *
 * @author Bernard
 */
public class Prosogramme {
  private double tmin, tmax;
  private double[][] points;
  private DefaultXYDataset dataset;
  public Prosogramme(double[] tlims, double[][] points, Tire syll) {
    this.tmin = tlims[0];
    this.tmax = tlims[1];
    this.points = points;
    double[][] data = calculerData(syll);
    dataset = new DefaultXYDataset();
    dataset.addSeries(0, data);
    dataset = new DefaultXYDataset();
    dataset.addSeries(0, data);
  }
  final private static double LOG2 = Math.log(2);
  private double[][] calculerData(Tire syll) {
    for (int i = 0; i<points[1].length; i++)
      points[1][i] = Math.log(points[1][i])/LOG2;
    // ajoute un NaN entre chaque syllabe
    double[] bornes = syll.getBornes();
    ArrayList<Integer> coupes = new ArrayList<Integer>();
    coupes.add(0);
    int ind = 1;
    for (int i = 0; i<bornes.length; i++) {
      if (ind>=points[0].length) break;
      double b = bornes[i];
      if (b<points[0][ind-1]) continue;
      while (b>points[0][ind]) {
        ind++;
        if (ind==points[0].length) break;
      }
      if (b>points[0][ind-1]) coupes.add(ind++);
    }
    double[][] data = new double[2][points[0].length+coupes.size()-2];
    int decalage = 0;
    for (int c = 0; c<coupes.size()-1; c++) {
      for (int i = coupes.get(c); i<coupes.get(c+1); i++) {
        data[0][i+decalage] = points[0][i];
        data[1][i+decalage] = points[1][i];
      }
      if (c==coupes.size()-2) break;
      int i = coupes.get(c+1);
      data[0][i+decalage] = (points[0][i]+points[0][i-1])/2;
      data[1][i+decalage] = Double.NaN;
      decalage++;
    }
    return data;
  }
  public XYDataset getDataSet() {
    return dataset;
  }
  public double getTmin() {
    return tmin;
  }
  public double getTmax() {
    return tmax;
  }
  public double[][] getPoints() {
    return points;
  }
  public double[] calculerBornes() {
    double min = Double.MAX_VALUE, max = -Double.MAX_VALUE;
    if (points[0].length==0) return null;
    for (int i = 0; i<points[0].length; i++) {
      double val = points[1][i];
      min = Math.min(min, val);
      max = Math.max(max, val);
    }
    return new double[]{min, max};
  }
  public static TableModel calculerTable(double[][] proso) {
    return new TableProsogramme(proso);
  }

  private static class TableProsogramme extends AbstractTableModel {
    final private static String[] nomsChamps =
            new String[]{"Tdébut", "Valdébut", "Tfin", "Valfin"};
    double[][] donnees;
    private TableProsogramme(double[][] proso) {
      boolean encours = false;
      ArrayList<Integer> debs = new ArrayList<Integer>();
      ArrayList<Integer> fins = new ArrayList<Integer>();
      for (int i = 0; i<proso[1].length; i++) {
        if (!encours&&!Double.isNaN(proso[1][i])) {
          debs.add(i);
          encours = true;
          continue;
        }
        if (encours&&Double.isNaN(proso[1][i])) {
          fins.add(i);
          encours = false;
          continue;
        }
      }
      if (encours) fins.add(proso[1].length);
      int nbinterv = 0;
      for (int i = 0; i<debs.size(); i++)
        nbinterv += fins.get(i)-debs.get(i)-1;
      donnees = new double[nbinterv][4];
      int no = 0;
      for (int i = 0; i<debs.size(); i++) {
        int k1 = debs.get(i);
        for (int k = k1; k<fins.get(i)-1; k++) {
          donnees[no][0] = proso[0][k];
          donnees[no][1] = Math.pow(2, proso[1][k]);
          donnees[no][2] = proso[0][k+1];
          donnees[no][3] =  Math.pow(2,proso[1][k+1]);
          no++;
        }
      }
    }
    @Override
    public int getRowCount() {
      return donnees.length;
    }
    @Override
    public int getColumnCount() {
      return 4;
    }
    @Override
    public String getColumnName(int col) {
      return nomsChamps[col];
    }
    @Override
    public String getValueAt(int row, int col) {
      return String.valueOf(donnees[row][col]);
    }
  }
}
