/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package visuAnalor.fichiers;

import java.io.*;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import visuAnalor.donnees.*;
import visuAnalor.parametres.Parametres2;
import visuAnalor.util.*;
import visuAnalor.util.Fichiers.*;

/**
 *
 * @author Bernard
 */
public class FichiersJava {
  public static boolean enregistrerDonnees(Donnees donnees, File fichier) {
    if (fichier!=null) return ecrireDonnees(donnees, fichier);
    else return enregistrerDonneesSous(donnees);
  }
  public static boolean enregistrerDonneesSous(Donnees donnees) {
    File fichier;
    if ((fichier = Fichiers.choisirFichier(Commande.ENREGISTRER,
            "Nom du fichier de donnees", Fichiers.TypeFichier.DONNEES))==null)
      return false;
    return ecrireDonnees(donnees, fichier);
  }
  private static boolean ecrireDonnees(Donnees donnees, File fichier) {
    ObjectOutputStream oos = null;
    try {
      oos = new ObjectOutputStream(new FileOutputStream(fichier));
      donnees.ecrireJava(oos);
      oos.close();
      return true;
    } catch (IOException ex) {
      JOptionPane.showMessageDialog(null, ex, "Erreur d'écriture de fichier", JOptionPane.ERROR_MESSAGE);
      if (oos!=null) try {
          oos.close();
        } catch (IOException ex1) {
        }
      return false;
    }
  }
  public static boolean ouvrirDonnees(Donnees donnees, String nomfichier) {
    File fichierDonnees;
    if (nomfichier.isEmpty()) {
      if ((fichierDonnees = Fichiers.choisirFichier(Commande.OUVRIR,
              "Choix du document", Fichiers.TypeFichier.DONNEES))==null)
        return false;
    } else {
      if ((fichierDonnees = Fichiers.trouverFichier(Fichiers.TypeFichier.DONNEES, nomfichier))==null) {
        JOptionPane.showMessageDialog(null, "Fichier "+nomfichier+" inexistant dans le répertoire "
                +Fichiers.getRepertoireCourant(Fichiers.TypeFichier.DONNEES).getPath(), "Erreur de lecture de fichier",
                JOptionPane.ERROR_MESSAGE);
        return false;
      }
    }
    boolean res = ouvrirDonnees(donnees, fichierDonnees, true);
    return res;
  }
  public static boolean ouvrirDonnees(Donnees donnees, File fichierDonnees, boolean fire) {
    ObjectInputStream ois = null;
    try {
      ois = new ObjectInputStream(new FileInputStream(fichierDonnees));
      donnees.lireJava(ois, fire);
      return true;
    } catch (ClassNotFoundException e) {
      JOptionPane.showMessageDialog(null, "Impossible de lire le document "+fichierDonnees.getName()
              +" : versions d'Analor incompatibles ",
              "Erreur d'ouverture de fichier .or", JOptionPane.ERROR_MESSAGE);
      return false;
    } catch (InvalidClassException e) {
      JOptionPane.showMessageDialog(null, "Impossible de lire le document "+fichierDonnees.getName()
              +" : versions d'Analor incompatibles ",
              "Erreur d'ouverture de fichier .or", JOptionPane.ERROR_MESSAGE);
      return false;
    } catch (ClassCastException e) {
      JOptionPane.showMessageDialog(null, "Impossible de lire le document "+fichierDonnees.getName()
              +" : versions d'Analor incompatibles ",
              "Erreur d'ouverture de fichier .or", JOptionPane.ERROR_MESSAGE);
      return false;
    } catch (IOException ex) {
      donnees.fermer();
      JOptionPane.showMessageDialog(null, ex, "Erreur de lecture de fichier", JOptionPane.ERROR_MESSAGE);
      return false;
    } finally {
      try {
        if (ois!=null) ois.close();
      } catch (IOException ex) {
        JOptionPane.showMessageDialog(null, ex, "Erreur de fermeture de fichier lu", JOptionPane.ERROR_MESSAGE);
      }
   }
  }
  public static void ouvrirParametres(Parametres2 params) {
    File fichierParams;
    if ((fichierParams = Fichiers.choisirFichier(Commande.OUVRIR,
            "Choix du paramétrage", Fichiers.TypeFichier.PARAMETRES))==null)
      return;
    ObjectInputStream ois = null;
    try {
      ois = new ObjectInputStream(new FileInputStream(fichierParams));
      params.lireJava(ois);
    } catch (InvalidClassException ex) {
      JOptionPane.showMessageDialog(null, "Impossible de lire le paramétrage "+fichierParams.getName(), "Erreur d'ouverture de fichier .orp", JOptionPane.ERROR_MESSAGE);
      return;
    } catch (ClassNotFoundException ex) {
      JOptionPane.showMessageDialog(null, "Impossible de lire le paramétrage  "+fichierParams.getName()
              +" : format inconnu", "Erreur d'ouverture de fichier .ecv", JOptionPane.ERROR_MESSAGE);
      return;
    } catch (ClassCastException ex) {
      JOptionPane.showMessageDialog(null, "Impossible de lire le paramétrage "+fichierParams.getName()
              +" : format inconnu ", "Erreur d'ouverture de fichier .ecv", JOptionPane.ERROR_MESSAGE);
      return;
    } catch (IOException ex) {
      JOptionPane.showMessageDialog(null, ex, "Erreur de lecture de fichier", JOptionPane.ERROR_MESSAGE);
      return;
    } finally {
      try {
        if (ois!=null) ois.close();
      } catch (IOException ex) {
        JOptionPane.showMessageDialog(null, ex, "Erreur de fermeture de fichier lu", JOptionPane.ERROR_MESSAGE);
      }
    }
  }
  public static boolean enregistrerParametres(Parametres2 parametres) {
    File fichier;
    if ((fichier = Fichiers.choisirFichier(Commande.ENREGISTRER,
            "Nom du fichier de paramétrage", Fichiers.TypeFichier.PARAMETRES))==null)
      return false;
    ObjectOutputStream oos = null;
    try {
      oos = new ObjectOutputStream(new FileOutputStream(fichier));
      parametres.ecrireJava(oos);
    } catch (IOException ex) {
      JOptionPane.showMessageDialog(null, ex, "Erreur d'écriture de fichier", JOptionPane.ERROR_MESSAGE);
      return false;
    } finally {
      try {
        if (oos!=null) oos.close();
        return true;
      } catch (IOException ex) {
        JOptionPane.showMessageDialog(null, ex, "Erreur de fermeture de fichier écrit", JOptionPane.ERROR_MESSAGE);
        return false;
      }
    }
  }
}
