/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package visuAnalor.fichiers;

import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.table.*;
import visuAnalor.donnees.*;
import visuAnalor.donnees.Tire.*;
import visuAnalor.util.*;
import visuAnalor.util.Fichiers.*;

/**
 *
 * @author Bernard
 */
public class FichiersTableur {
  public static void exporterTable(TableModel donnees, TypeFichier typefichier) {
    PrintWriter ecrittableur = null;
    File fichierStats;
    String titre;
    switch(typefichier) {
      case TABLEUR_PARAMS:
        titre = "Nom du fichier de paramètres";
        break;
      case TABLEUR_STATS:
        titre = "Nom du fichier de résultats";
        break;
      case PROSOGRAMME:
        titre = "Nom du fichier Prosogramme";
        break;
      case TABLEUR_TIRE:
        titre = donnees.getColumnName(1);  // pas très sécure, mais enfin!
        break;
      default:
        throw new IllegalArgumentException("type non traité par FichiersTableur");
    }
    GCodage codage = new GCodage();
    if ((fichierStats = Fichiers.choisirFichier(Commande.ENREGISTRER,
            titre, typefichier, codage.getContenant()))==null) return;
    String code = codage.getCode();
    try {
      ecrittableur = new PrintWriter(fichierStats, code);
      ecrireTable(ecrittableur, donnees);
    } catch (FileNotFoundException ex) {
      GMessages.impossibiliteAction("Erreur d'écriture de fichier :\n"+ex);
    } catch (UnsupportedEncodingException ex) {
      GMessages.impossibiliteAction("Erreur d'écriture de fichier :\n" +
              "Codage de caractères non pris en charge : "+code);
    } finally {
      if (ecrittableur!=null) ecrittableur.close();
    }
  }
  private static void ecrireTable(PrintWriter ecrittableur, TableModel donnees) {
    int nbcol = donnees.getColumnCount();
    for (int j = 0; j<nbcol; j++) {
      ecrittableur.print(donnees.getColumnName(j));
      ecrittableur.print(j==nbcol-1 ? '\n' : '\t');
    }
    int nblig = donnees.getRowCount();
    for (int i = 0; i<nblig; i++) for (int j = 0; j<nbcol; j++) {
        ecrittableur.print(donnees.getValueAt(i, j));
        ecrittableur.print(j==nbcol-1 ? '\n' : '\t');
      }

  }
}
