/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package visuAnalor.parametres;

import java.io.*;
import java.lang.reflect.*;
import java.util.*;
import javax.swing.table.*;
import visuAnalor.parametres.MessageParametres.*;
import visuAnalor.util.GMessages;

/**
 *
 * @author Bernard
 */
public class Parametres implements Serializable {
  public static interface ParametresListener extends EventListener {
    void traiterEventParametres(MessageParametres e);
  }
  private final static int VERSION = 1;
  private String nomTirePausesPeriodes;
  private String nomTireEuh;
  private String nomTireLocuteurs;
  private String nomTirePeriodesCalculees;
  private String nomTirePhonemes;
  private String nomTireSyllabesProsogrammes;
  private String nomTireSyllabesProms;
  private String nomTireDysFluences;
  private String nomTirePromsReference;
  private String nomTirePromsCalculees;
  private String nomTirePromsForce;
  private String[] marquesPausePeriodes;
  private String[] marquesEuh;
  private String[] voyelles;
  private String[] marquesPauseProms;
  private String[] marquesDysFluences;
  private String[] marquesPromsReference;
  private String marquePromsFortesCalculees;
  private String marquePromsFaiblesCalculees;
  private double fenetreLissage;
  private double ecartmaxLissage;
  private double euhDescendantPeriodes;
  private double distanceMaximumPeriodes;
  private double registrePeriodes;
  private double[] echelleSautPeriodes;
  private double[] echellePausePeriodes;
  private double[] echelleGestePeriodes;
  private boolean restrictionVocalique;
  private double poidsPhonemes;
  private int[] empans;
  private boolean compteSyllabeCentrale;
  private double seuilDureeProms;
  private double seuilHauteurProms;
  private double seuilMonteeProms;
  private double penteForceDuree;
  private double penteForceHauteur;
  private double penteForceMontee;
  private double poidsForceDuree;
  private double poidsForceHauteur;
  private double poidsForceMontee;
  private double poidsForcePause;
  private transient TableParams tableur;
  private transient ArrayList<ParametresListener> listeCorrespondants = new ArrayList<ParametresListener>();
  private transient boolean modifie = false;
  private static Parametres paramDefauts = new Parametres();
  static {
    paramDefauts.nomTirePausesPeriodes = "syllabe";
    paramDefauts.marquesPausePeriodes = new String[]{"_", "<", "#", "*"};
    paramDefauts.nomTireEuh = "syllabe";
    paramDefauts.nomTirePeriodesCalculees = "periode";
    paramDefauts.nomTireSyllabesProsogrammes = "syllabe";
    paramDefauts.marquesEuh = new String[]{"euh", "2", "9"};
    paramDefauts.nomTireLocuteurs = "locuteur";
    paramDefauts.ecartmaxLissage = 2.5/12;
    paramDefauts.fenetreLissage = 0.5;
    paramDefauts.euhDescendantPeriodes = 2.5/12;
    paramDefauts.distanceMaximumPeriodes = 0.2;
    paramDefauts.registrePeriodes = 2.5/12;
    paramDefauts.echellePausePeriodes = new double[]{0.25, 0.33, 0.66};
    paramDefauts.echelleSautPeriodes = new double[]{2./12, 3.5/12, 7./12};
    paramDefauts.echelleGestePeriodes = new double[]{3./12, 5./12, 8./12};
    paramDefauts.nomTirePhonemes = "phones";
    paramDefauts.nomTireSyllabesProms = "syllabe";
    paramDefauts.nomTireDysFluences = "hésitations";
    paramDefauts.nomTirePromsReference = "prom";
    paramDefauts.nomTirePromsCalculees = "prom-Analor";
    paramDefauts.nomTirePromsForce = "prom-force";
    paramDefauts.voyelles = new String[]{"a", "e", "i", "o", "y", "u", "@", "2", "9", "E",
      "O", "e~", "E~", "9~", "a~", "o~"};
    paramDefauts.marquesPauseProms = new String[]{"_", "<", "#", "*"};
    paramDefauts.marquesDysFluences = new String[]{"H"};
    paramDefauts.marquesPromsReference = new String[]{"S", "W"};
    paramDefauts.marquePromsFortesCalculees = "P";
    paramDefauts.marquePromsFaiblesCalculees = "p";
    paramDefauts.seuilMonteeProms = 9.6/12;
    paramDefauts.restrictionVocalique = true;
    paramDefauts.poidsPhonemes = 0.5;
    paramDefauts.empans = new int[]{2, 2};
    paramDefauts.compteSyllabeCentrale = false;
    paramDefauts.seuilDureeProms = 1.5;
    paramDefauts.seuilHauteurProms = 1.5/12;
    paramDefauts.penteForceDuree = 1.5;
    paramDefauts.penteForceHauteur = 1.5;
    paramDefauts.penteForceMontee = 1.5;
    paramDefauts.poidsForceDuree = 1.;
    paramDefauts.poidsForceHauteur = 1.;
    paramDefauts.poidsForceMontee = 1.;
    paramDefauts.poidsForcePause = 0.5;
  }
  public void addEventListener(ParametresListener correspondant) {
    listeCorrespondants.add(correspondant);
  }
  public void removeEventListener(ParametresListener correspondant) {
    listeCorrespondants.remove(correspondant);
  }
  void fireMessage(MessageParametres evt) {
    for (Object corresp : listeCorrespondants.toArray()) {
      ((ParametresListener) corresp).traiterEventParametres(evt);
    }
  }
  public boolean isModifie() {
    return modifie;
  }
  private String getValeur(Field champ) {
    Object val = null;
    try {
      val = champ.get(this);
      if (!val.getClass().isArray()) return val.toString();
    } catch (Exception ex) {
      GMessages.erreurFatale(ex);
    }
    String valeur = "|";
    try {
      for (int i = 0; i<Array.getLength(val); i++)
        valeur += Array.get(val, i).toString()+"|";

    } catch (Exception ex) {
      GMessages.erreurFatale(ex);
    }
    return valeur;
  }
  public void initDefauts() {
    copier(paramDefauts);
    modifie = false;
    fireMessage(new MessageParametres(this, TypeMessage.NEW_PARAMS));

  }
  public void copier(Parametres param) {
    nomTirePausesPeriodes = param.nomTirePausesPeriodes;
    marquesPausePeriodes = param.marquesPausePeriodes;
    nomTireEuh = param.nomTireEuh;
    marquesEuh = param.marquesEuh;
    nomTireLocuteurs = param.nomTireLocuteurs;
    nomTirePeriodesCalculees = param.nomTirePeriodesCalculees;
    nomTireSyllabesProsogrammes = param.nomTireSyllabesProsogrammes;
    ecartmaxLissage = param.ecartmaxLissage;
    fenetreLissage = param.fenetreLissage;
    euhDescendantPeriodes = param.euhDescendantPeriodes;
    distanceMaximumPeriodes = param.distanceMaximumPeriodes;
    registrePeriodes = param.registrePeriodes;
    echellePausePeriodes = param.echellePausePeriodes;
    echelleGestePeriodes = param.echelleGestePeriodes;
    echelleSautPeriodes = param.echelleSautPeriodes;
    nomTirePhonemes = param.nomTirePhonemes;
    nomTireSyllabesProms = param.nomTireSyllabesProms;
    nomTireDysFluences = param.nomTireDysFluences;
    nomTirePromsReference = param.nomTirePromsReference;
    nomTirePromsCalculees = param.nomTirePromsCalculees;
    nomTirePromsForce = param.nomTirePromsForce;
    voyelles = param.voyelles;
    marquesPauseProms = param.marquesPauseProms;
    marquesDysFluences = param.marquesDysFluences;
    marquesPromsReference = param.marquesPromsReference;
    marquePromsFortesCalculees = param.marquePromsFortesCalculees;
    marquePromsFaiblesCalculees = param.marquePromsFaiblesCalculees;
    seuilMonteeProms = param.seuilMonteeProms;
    restrictionVocalique = param.restrictionVocalique;
    poidsPhonemes = param.poidsPhonemes;
    empans = param.empans;
    compteSyllabeCentrale = param.compteSyllabeCentrale;
    seuilDureeProms = param.seuilDureeProms;
    seuilHauteurProms = param.seuilHauteurProms;
    penteForceDuree = param.penteForceDuree;
    penteForceHauteur = param.penteForceHauteur;
    penteForceMontee = param.penteForceMontee;
    poidsForceDuree = param.poidsForceDuree;
    poidsForceHauteur = param.poidsForceHauteur;
    poidsForceMontee = param.poidsForceMontee;
    poidsForcePause = param.poidsForcePause;
  }
  void setParametresSaisis(Parametres param) {
    EnumMap<TypeMessage, Boolean> isModifie =
            new EnumMap<TypeMessage, Boolean>(TypeMessage.class);
    for (TypeMessage type : TypeMessage.values()) isModifie.put(type, false);
    if (!nomTirePausesPeriodes.equals(param.nomTirePausesPeriodes)) {
      nomTirePausesPeriodes = param.nomTirePausesPeriodes;
      isModifie.put(TypeMessage.LISSAGE, true);
      isModifie.put(TypeMessage.PERIODES, true);
    }
    if (!Arrays.equals(marquesPausePeriodes, param.marquesPausePeriodes)) {
      marquesPausePeriodes = param.marquesPausePeriodes;
      isModifie.put(TypeMessage.LISSAGE, true);
      isModifie.put(TypeMessage.PERIODES, true);
    }
    if (!nomTireEuh.equals(param.nomTireEuh)) {
      nomTireEuh = param.nomTireEuh;
      isModifie.put(TypeMessage.PERIODES, true);
    }
    if (!Arrays.equals(marquesEuh, param.marquesEuh)) {
      marquesEuh = param.marquesEuh;
      isModifie.put(TypeMessage.PERIODES, true);
    }
    if (!nomTireLocuteurs.equals(param.nomTireLocuteurs)) {
      nomTireLocuteurs = param.nomTireLocuteurs;
      isModifie.put(TypeMessage.LISSAGE, true);
      isModifie.put(TypeMessage.PERIODES, true);
    }
    if (!nomTireSyllabesProsogrammes.equals(param.nomTireSyllabesProsogrammes)) {
      nomTireSyllabesProsogrammes = param.nomTireSyllabesProsogrammes;
    }
    if (!nomTirePeriodesCalculees.equals(param.nomTirePeriodesCalculees)) {
      nomTirePeriodesCalculees = param.nomTirePeriodesCalculees;
      isModifie.put(TypeMessage.PERIODES, true);
    }
    if (Math.round(ecartmaxLissage*100)
            !=Math.round(param.ecartmaxLissage*100)) {
      ecartmaxLissage = param.ecartmaxLissage;
      isModifie.put(TypeMessage.LISSAGE, true);
    }
    if (Math.round(fenetreLissage*1000)
            !=Math.round(param.fenetreLissage*1000)) {
      fenetreLissage = param.fenetreLissage;
      isModifie.put(TypeMessage.LISSAGE, true);
    }
    if (Math.round(euhDescendantPeriodes*100)
            !=Math.round(param.euhDescendantPeriodes*100)) {
      euhDescendantPeriodes = param.euhDescendantPeriodes;
      isModifie.put(TypeMessage.PERIODES, true);
    }
    if (Math.round(distanceMaximumPeriodes*1000)
            !=Math.round(param.distanceMaximumPeriodes*1000)) {
      distanceMaximumPeriodes = param.distanceMaximumPeriodes;
      isModifie.put(TypeMessage.PERIODES, true);
    }
    if (Math.round(registrePeriodes*100)
            !=Math.round(param.registrePeriodes*100)) {
      registrePeriodes = param.registrePeriodes;
      isModifie.put(TypeMessage.PERIODES, true);
    }
    for (int i = 0; i<echellePausePeriodes.length; i++)
      if (Math.round(echellePausePeriodes[i]*1000)
              !=Math.round(param.echellePausePeriodes[i]*1000)) {
        echellePausePeriodes[i] = param.echellePausePeriodes[i];
        isModifie.put(TypeMessage.PERIODES, true);
      }
    for (int i = 0; i<echelleSautPeriodes.length; i++)
      if (Math.round(echelleSautPeriodes[i]*100)
              !=Math.round(param.echelleSautPeriodes[i]*100)) {
        echelleSautPeriodes[i] = param.echelleSautPeriodes[i];
        isModifie.put(TypeMessage.PERIODES, true);
      }
    for (int i = 0; i<echelleGestePeriodes.length; i++)
      if (Math.round(echelleGestePeriodes[i]*100)
              !=Math.round(param.echelleGestePeriodes[i]*100)) {
        echelleGestePeriodes[i] = param.echelleGestePeriodes[i];
        isModifie.put(TypeMessage.PERIODES, true);
      }
    if (!nomTirePhonemes.equals(param.nomTirePhonemes)) {
      nomTirePhonemes = param.nomTirePhonemes;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    if (!nomTireSyllabesProms.equals(param.nomTireSyllabesProms)) {
      nomTireSyllabesProms = param.nomTireSyllabesProms;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    if (!nomTireDysFluences.equals(param.nomTireDysFluences)) {
      nomTireDysFluences = param.nomTireDysFluences;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }

    if (!nomTirePromsReference.equals(param.nomTirePromsReference)) {
      nomTirePromsReference = param.nomTirePromsReference;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    if (!nomTirePromsCalculees.equals(param.nomTirePromsCalculees)) {
      nomTirePromsCalculees = param.nomTirePromsCalculees;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    if (!nomTirePromsForce.equals(param.nomTirePromsForce)) {
      nomTirePromsForce = param.nomTirePromsForce;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    if (!Arrays.equals(voyelles, param.voyelles)) {
      voyelles = param.voyelles;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    if (!Arrays.equals(marquesPauseProms, param.marquesPauseProms)) {
      marquesPauseProms = param.marquesPauseProms;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    if (!Arrays.equals(marquesDysFluences, param.marquesDysFluences)) {
      marquesDysFluences = param.marquesDysFluences;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    marquesPromsReference = param.marquesPromsReference;
    if (!marquePromsFortesCalculees.equals(param.marquePromsFortesCalculees)) {
      marquePromsFortesCalculees = param.marquePromsFortesCalculees;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    if (!marquePromsFaiblesCalculees.equals(param.marquePromsFaiblesCalculees)) {
      marquePromsFaiblesCalculees = param.marquePromsFaiblesCalculees;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    if (Math.round(seuilMonteeProms*100)!=Math.round(param.seuilMonteeProms*100)) {
      seuilMonteeProms = param.seuilMonteeProms;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    if (restrictionVocalique!=param.restrictionVocalique) {
      restrictionVocalique = param.restrictionVocalique;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    if (Math.round(poidsPhonemes*100)!=Math.round(param.poidsPhonemes*100)) {
      poidsPhonemes = param.poidsPhonemes;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    if (!Arrays.equals(empans, param.empans)) {
      empans = param.empans;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    if (compteSyllabeCentrale!=param.compteSyllabeCentrale) {
      compteSyllabeCentrale = param.compteSyllabeCentrale;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    if (Math.round(seuilDureeProms*100)!=Math.round(param.seuilDureeProms*100)) {
      seuilDureeProms = param.seuilDureeProms;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    if (Math.round(seuilHauteurProms*100)!=Math.round(param.seuilHauteurProms*100)) {
      seuilHauteurProms = param.seuilHauteurProms;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    if (Math.round(penteForceDuree*100)!=Math.round(param.penteForceDuree*100)) {
      penteForceDuree = param.penteForceDuree;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    if (Math.round(penteForceHauteur*100)!=Math.round(param.penteForceHauteur*100)) {
      penteForceHauteur = param.penteForceHauteur;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    if (Math.round(penteForceMontee*100)!=Math.round(param.penteForceMontee*100)) {
      penteForceMontee = param.penteForceMontee;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    if (Math.round(poidsForceDuree*100)!=Math.round(param.poidsForceDuree*100)) {
      poidsForceDuree = param.poidsForceDuree;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    if (Math.round(poidsForceHauteur*100)!=Math.round(param.poidsForceHauteur*100)) {
      poidsForceHauteur = param.poidsForceHauteur;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    if (Math.round(poidsForceMontee*100)!=Math.round(param.poidsForceMontee*100)) {
      poidsForceMontee = param.poidsForceMontee;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    if (Math.round(poidsForcePause*100)!=Math.round(param.poidsForcePause*100)) {
      poidsForcePause = param.poidsForcePause;
      isModifie.put(TypeMessage.PROEMINENCES, true);
    }
    // Envoi des messages
    if (isModifie.get(TypeMessage.AFFICHAGE)) {
      modifie = true;
      fireMessage(new MessageParametres(this, TypeMessage.AFFICHAGE));
    }
    if (isModifie.get(TypeMessage.LISSAGE)) {
      modifie = true;
      fireMessage(new MessageParametres(this, TypeMessage.LISSAGE));
    }
    if (isModifie.get(TypeMessage.PERIODES)) {
      modifie = true;
      fireMessage(new MessageParametres(this, TypeMessage.PERIODES));
    }
    if (isModifie.get(TypeMessage.PROEMINENCES)) {
      modifie = true;
      fireMessage(new MessageParametres(this, TypeMessage.PROEMINENCES));
    }
  }
  public void modifApprendProeminences() {
    modifie = true;
    fireMessage(new MessageParametres(this, TypeMessage.PROEMINENCES));
  }
  public String getNomTirePausesPeriodes() {
    return nomTirePausesPeriodes;
  }
  public void setNomTirePausesPeriodes(String nom) {
    nomTirePausesPeriodes = nom;
  }
  public String getNomTireEuh() {
    return nomTireEuh;
  }
  public void setNomTireEuh(String nom) {
    nomTireEuh = nom;
  }
  public String getNomTireLocuteurs() {
    return nomTireLocuteurs;
  }
  public void setNomTireLocuteurs(String nom) {
    nomTireLocuteurs = nom;
  }
  public String getNomTirePeriodesCalculees() {
    return nomTirePeriodesCalculees;
  }
  public void setNomTirePeriodesCalculees(String nom) {
    nomTirePeriodesCalculees = nom;
  }
  public String getNomTireSyllabesProsogrammes() {
    return nomTireSyllabesProsogrammes;
  }
  public void setNomTireSyllabesProsogrammes(String nom) {
    nomTireSyllabesProsogrammes = nom;
  }
  public String[] getMarquesPausePeriodes() {
    return marquesPausePeriodes;
  }
  public void setMarquesPausePeriodes(String[] marques) {
    marquesPausePeriodes = marques;
  }
  public String[] getMarquesEuh() {
    return marquesEuh;
  }
  public void setMarquesEuh(String[] marques) {
    marquesEuh = marques;
  }
  public double getEcartmaxLissage() {
    return ecartmaxLissage;
  }
  public void setEcartmaxLissage(double ecart) {
    ecartmaxLissage = ecart;
  }
  public double getFenetreLissage() {
    return fenetreLissage;
  }
  public void setFenetreLissage(double fenetre) {
    fenetreLissage = fenetre;
  }
  public double getEuhDescendantPeriodes() {
    return euhDescendantPeriodes;
  }
  public void setEuhDescendantPeriodes(double seuil) {
    euhDescendantPeriodes = seuil;
  }
  public double getDistanceMaximumPeriodes() {
    return distanceMaximumPeriodes;
  }
  public void setDistanceMaximumPeriodes(double seuil) {
    distanceMaximumPeriodes = seuil;
  }
  public double getRegistrePeriodes() {
    return registrePeriodes;
  }
  public void setRegistrePeriodes(double seuil) {
    registrePeriodes = seuil;
  }
  public double[] getEchellePausePeriodes() {
    return echellePausePeriodes;
  }
  public void setEchellePausePeriodes(double[] echelle) {
    echellePausePeriodes = echelle;
  }
  public double[] getEchelleGestePeriodes() {
    return echelleGestePeriodes;
  }
  public void setEchelleGestePeriodes(double[] echelle) {
    echelleGestePeriodes = echelle;
  }
  public double[] getEchelleSautPeriodes() {
    return echelleSautPeriodes;
  }
  public void setEchelleSautPeriodes(double[] echelle) {
    echelleSautPeriodes = echelle;
  }
  public String getNomTirePhonemes() {
    return nomTirePhonemes;
  }
  public void setNomTirePhonemes(String nom) {
    nomTirePhonemes = nom;
  }
  public String getNomTireSyllabesProms() {
    return nomTireSyllabesProms;
  }
  public void setNomTireSyllabesProms(String nom) {
    nomTireSyllabesProms = nom;
  }
  public String getNomTireDysFluences() {
    return nomTireDysFluences;
  }
  public void setNomTireDysFluences(String nom) {
    nomTireDysFluences = nom;
  }
  public String getNomTirePromsReference() {
    return nomTirePromsReference;
  }
  public void setNomTirePromsReference(String nom) {
    nomTirePromsReference = nom;
  }
  public String getNomTirePromsCalculees() {
    return nomTirePromsCalculees;
  }
  public void setNomTirePromsCalculees(String nom) {
    nomTirePromsCalculees = nom;
  }
  public String getNomTirePromsForce() {
    return nomTirePromsForce;
  }
  public void setNomTirePromsForce(String nom) {
    nomTirePromsForce = nom;
  }
  public String[] getVoyelles() {
    return voyelles;
  }
  public void setVoyelles(String[] marques) {
    voyelles = marques;
  }
  public String[] getMarquesPauseProms() {
    return marquesPauseProms;
  }
  public void setMarquesPauseProms(String[] marques) {
    marquesPauseProms = marques;
  }
  public String[] getMarquesDysFluences() {
    return marquesDysFluences;
  }
  public void setMarquesDysFluences(String[] marques) {
    marquesDysFluences = marques;
  }
  public String[] getMarquesPromsReference() {
    return marquesPromsReference;
  }
  public void setMarquesPromsReference(String[] marques) {
    marquesPromsReference = marques;
  }
  public String getMarquePromsFortesCalculees() {
    return marquePromsFortesCalculees;
  }
  public void setMarquePromsFortesCalculees(String marque) {
    marquePromsFortesCalculees = marque;
  }
  public String getMarquePromsFaiblesCalculees() {
    return marquePromsFaiblesCalculees;
  }
  public void setMarquePromsFaiblesCalculees(String marque) {
    marquePromsFaiblesCalculees = marque;
  }
  public boolean getRestrictionVocalique() {
    return restrictionVocalique;
  }
  public void setRestrictionVocalique(boolean rep) {
    restrictionVocalique = rep;
  }
  public double getPoidsPhonemes() {
    return poidsPhonemes;
  }
  public void setPoidsPhonemes(double poids) {
    poidsPhonemes = poids;
  }
  public int[] getEmpans() {
    return empans;
  }
  public void setEmpans(int[] nbs) {
    empans = nbs;
  }
  public boolean getCompteSyllabeCentrale() {
    return compteSyllabeCentrale;
  }
  public void setCompteSyllabeCentrale(boolean rep) {
    compteSyllabeCentrale = rep;
  }
  public double getSeuilDureeProms() {
    return seuilDureeProms;
  }
  public void setSeuilDureeProms(double seuil) {
    seuilDureeProms = seuil;
  }
  public double getSeuilHauteurProms() {
    return seuilHauteurProms;
  }
  public double getSeuilMonteeProms() {
    return seuilMonteeProms;
  }
  public void setSeuilMonteeProms(double seuil) {
    seuilMonteeProms = seuil;
  }
  public void setSeuilHauteurProms(double seuil) {
    seuilHauteurProms = seuil;
  }
  public double getPenteForceDuree() {
    return penteForceDuree;
  }
  public void setPenteForceDuree(double pente) {
    penteForceDuree = pente;
  }
  public double getPenteForceHauteur() {
    return penteForceHauteur;
  }
  public void setPenteForceHauteur(double pente) {
    penteForceHauteur = pente;
  }
  public double getPenteForceMontee() {
    return penteForceMontee;
  }
  public void setPenteForceMontee(double pente) {
    penteForceMontee = pente;
  }
  public double getPoidsForceDuree() {
    return poidsForceDuree;
  }
  public void setPoidsForceDuree(double poids) {
    poidsForceDuree = poids;
  }
  public double getPoidsForceHauteur() {
    return poidsForceHauteur;
  }
  public void setPoidsForceHauteur(double poids) {
    poidsForceHauteur = poids;
  }
  public double getPoidsForceMontee() {
    return poidsForceMontee;
  }
  public void setPoidsForceMontee(double poids) {
    poidsForceMontee = poids;
  }
  public double getPoidsForcePause() {
    return poidsForcePause;
  }
  public void setPoidsForcePause(double poids) {
    poidsForcePause = poids;
  }
  public void ecrireJava(ObjectOutputStream oos) throws IOException {
    oos.writeInt(VERSION);
    oos.writeObject(this);
    modifie = false;
  }
  public void lireJava(ObjectInputStream ois)
          throws IOException, ClassNotFoundException {
    int version = ois.readInt();
    if (version!=VERSION)
      throw new IOException("Version de paramétrage non prise en charge");
    Parametres params = (Parametres) ois.readObject();
    copier(params);
    modifie = false;
    fireMessage(new MessageParametres(this, TypeMessage.NEW_PARAMS));
  }
  public TableParams getModeleTableur() {
    if (tableur==null) tableur = new TableParams(this);
    return tableur;
  }

  private static class TableParams extends AbstractTableModel {
    Parametres params;
    ArrayList<Field> champs = new ArrayList<Field>();
    TableParams(Parametres params) {
      this.params = params;
      int nb = 0;
      for (Field champ : Parametres.class.getDeclaredFields())
        if (!Modifier.isTransient(champ.getModifiers())
                &&!Modifier.isStatic(champ.getModifiers())) champs.add(champ);
    }
    @Override
    public int getRowCount() {
      return champs.size();
    }
    @Override
    public int getColumnCount() {
      return 2;
    }
    @Override
    public String getColumnName(int col) {
      return col==0 ? "PARAMETRE" : "VALEUR";
    }
    @Override
    public String getValueAt(int row, int col) {
      switch (col) {
        case 0:
          return champs.get(row).getName();
        case 1:
          return params.getValeur(champs.get(row));
        default:
          GMessages.erreurFatale(new IllegalArgumentException(
                  "TableParams : plus de 2 colonnes"));
      }
      return null;
    }
  }
}
