/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package visuAnalor.parametres;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.TitledBorder;
import visuAnalor.parametres.MessageParametres.*;
import visuAnalor.util.*;
import visuAnalor.util.GMessages.*;

/**
 *
 * @author Bernard
 */
public class VisuParametres extends JDialog
        implements Parametres2.ParametresListener, ActionListener {
  static private VisuParametres instance = null;
  private Parametres2 parametres;
  private SaisieParametre saisieNomTirePausesPeriodes = new SaisieParametre(this, 1,
          "Tire indiquant les pauses",
          "Nom de la tire", "indiquant les pauses");
  private SaisieParametre saisieNomTireEuh = new SaisieParametre(this, 1,
          "Tire indiquant les \"euh\"",
          "Nom de la tire", "indiquant les \"euh\"");
  private SaisieParametre saisieNomTireSyllabesProsogrammes = new SaisieParametre(this, 1,
          "Tire syllabique pour prosogrammes", "Nom de la tire",
          "syllabique utilisée", "pour les prosogrammes");
  private SaisieParametre saisieNomTireLocuteurs = new SaisieParametre(this, 1,
          "Tire indiquant les locuteurs",
          "Nom de la tire", "indiquant les locuteurs");
  private SaisieParametre saisieNomTirePeriodesReference = new SaisieParametre(this, 1,
           "Tire indiquant les périodes de référence", "Nom de la tire indiquant",
          "les périodes de référence", "(pour l'apprentissage)");
  private SaisieParametre saisieNomTirePeriodesCalculees = new SaisieParametre(this, 1,
          "Tire de détection de périodes", "Nom de la tire",
          "indiquant les résultats", "de la détection de périodes");
  private SaisieParametre saisieMarquesPausePeriodes = new SaisieParametre(this, 1,
          "Marques de pause",
          "Marques de pause", "(séparateur : point-virgule)");
  private SaisieParametre saisieMarquesEuh = new SaisieParametre(this, 1,
          "Marques de \"euh\"",
          "Marques de \"euh\"", "(séparateur : point-virgule)");
  private SaisieParametre saisieFenetreLissage = new SaisieParametre(this, 1,
          "Lissage : Fenêtre maximale",
          "Lissage : Fenêtre maximale", "(en secondes)");
  private SaisieParametre saisieEcartMaxLissage = new SaisieParametre(this, 1,
          "Lissage : Ecart maximal",
          "Lissage : Ecart maximal", "(en demi-tons)");
  private SaisieParametre saisieEuhDescendantPeriode = new SaisieParametre(this, 1,
          "Périodes : seuil pour \"euh\" descendant",
          "Périodes : seuil de baisse", "pour \"euh\" descendant", "(en demi-tons)");
  private SaisieParametre saisieDistanceMaximumPeriode = new SaisieParametre(this, 1,
          "Périodes : seuil de distance pour un maximum terminal",
          "Périodes : seuil de distance", "pour un maximum terminal",
          "(en secondes)");
  private SaisieParametre saisieRegistrePeriode = new SaisieParametre(this, 1,
          "Périodes : seuil pour les registres",
          "Périodes : seuil de hauteur", "pour les registres",
          "(en demi-tons)");
  private SaisieParametre saisieSeuilPausePeriodes = new SaisieParametre(this, 1,
          "Périodes : Seuil de durée des pauses",
          "Périodes : Seuil de durée des pauses", "(en secondes)");
  private SaisieParametre saisieSeuilGestePeriodes = new SaisieParametre(this, 1,
          "Périodes : Seuil de hauteur des gestes",
          "Périodes : Seuil de hauteur des gestes", "(en demi-tons)");
  private SaisieParametre saisieSeuilSautPeriodes = new SaisieParametre(this, 1,
          "Périodes : Seuil de hauteur des sauts",
          "Périodes : Seuil de hauteur des sauts", "(en demi-tons)");
  private SaisieParametre saisiePoidsPausePeriodes = new SaisieParametre(this, 1,
          "Périodes : Poids de la durée des pauses",
          "Périodes : Poids de la durée des pauses", "(en secondes)");
  private SaisieParametre saisiePoidsGestePeriodes = new SaisieParametre(this, 1,
          "Périodes : Poids de la hauteur des gestes",
          "Périodes : Poids de la hauteur des gestes", "(en demi-tons)");
  private SaisieParametre saisiePoidsSautPeriodes = new SaisieParametre(this, 1,
          "Périodes : Poids de la hauteur des sauts",
          "Périodes : Poids de la hauteur des sauts", "(en demi-tons)");
  private SaisieParametre saisieNomTirePhonemes = new SaisieParametre(this, 1,
          "Tire indiquant les phonèmes",
          "Nom de la tire", "indiquant les phonèmes");
  private SaisieParametre saisieNomTireSyllabesProms = new SaisieParametre(this, 1,
          "Tire indiquant les syllabes",
          "Nom de la tire", "indiquant les syllabes");
  private SaisieParametre saisieNomTireDysFluences = new SaisieParametre(this, 1,
          "Tire indiquant les dysfluences",
          "Nom de la tire", "indiquant les dysfluences");
  private SaisieParametre saisieNomTirePromsReference = new SaisieParametre(this, 1,
          "Tire indiquant les proéminences de référence", "Nom de la tire indiquant",
          "les proéminences de référence", "(pour l'apprentissage)");
  private SaisieParametre saisieNomTirePromsCalculees = new SaisieParametre(this, 1,
          "Tire de détection des proéminences", "Nom de la tire",
          "indiquant les résultats", "de la détection des proéminences");
  private SaisieParametre saisieNomTirePromsForce = new SaisieParametre(this, 1,
          "Tire de calcul de la force de proéminence", "Nom de la tire indiquant",
          "les résultats du calcul", "de la force de proéminence");
  private SaisieParametre saisieVoyelles = new SaisieParametre(this, 1,
          "Marques de voyelles",
          "Marques de voyelles", "(séparateur : point-virgule)");
  private SaisieParametre saisieMarquesPauseProms = new SaisieParametre(this, 1,
          "Marques de pause",
          "Marques de pause", "(séparateur : point-virgule)");
  private SaisieParametre saisieMarquesDysFluences = new SaisieParametre(this, 1,
          "Marques de dysfluence",
          "Marques de dysfluence", "(séparateur : point-virgule)");
  private SaisieParametre saisieMarquesPromsReference = new SaisieParametre(this, 1,
          "Marques de proéminence de référence", "Marques de proéminence",
          "(tire de référence)", "(séparateur : point-virgule)");
  private SaisieParametre saisieMarquesPromsCalculees = new SaisieParametre(this, 1,
          "Marques des proéminences détectées", "Marques des proéminences calculées",
          "(tire de détection)", "(format : faible;forte)");
  private SaisieParametre saisieRestrictionVocalique = new SaisieParametre(this, 1,
          "Proéminences : restriction au noyau vocalique",
          "Restriction de la fondamentale", "au noyau vocalique", "(oui/non)");
  private SaisieParametre saisiePoidsPhonemes = new SaisieParametre(this, 1,
          "Proéminences : poids des phonèmes",
          "Poids des phonèmes dans le calcul", "(entre 0 et 1)");
  private SaisieParametre saisieEmpans = new SaisieParametre(this, 2,
          "Proéminences : empan",
          "Taille de l'empan", "(gauche - droite)");
  private SaisieParametre saisieCompteSyllabeCentrale = new SaisieParametre(this, 1,
          "Proéminences : syllabe centrale",
          "Prise en compte", "de la syllabe centrale", "(oui/non)");
  private SaisieParametre saisieSeuilDureeProms = new SaisieParametre(this, 1,
          "Proéminences : seuil de durée",
          "Seuil pour la durée", "(écart relatif)");
  private SaisieParametre saisieSeuilHauteurProms = new SaisieParametre(this, 1,
          "Proéminences : seuil de hauteur",
          "Seuil pour les hauteurs", "(en demi-tons)");
  private SaisieParametre saisieSeuilMonteeProms = new SaisieParametre(this, 1,
          "Proéminences : seuil pour la montée intrasyllabique",
          "Seuil pour la montée intrasyllabique", "(en demi-tons)");
  private SaisieParametre saisiePenteForce = new SaisieParametre(this, 3,
          "Force de proéminence : pentes des fonctions",
          "Pentes des fonctions", "pour le calcul des forces",
          "(durée - hauteur - montée)");
  private SaisieParametre saisiePoidsForce = new SaisieParametre(this, 4,
          "Force de proéminence : poids des critères",
          "Poids des critères", "pour le calcul des forces",
          "(durée - hauteur - montée - pause adj.)");
  static public void newVisuParametres(Frame fenetre, Parametres2 param) {
    if (instance==null) instance = new VisuParametres(fenetre, param);
    instance.setValeursParametres();
    instance.setVisible(true);

  }
  private VisuParametres(Frame fenetre, Parametres2 param) {
    super(null, "Gestion des paramètres", ModalityType.MODELESS);
    setAlwaysOnTop(false);
    JPanel cadre = new JPanel(new BorderLayout());
    setContentPane(cadre);
    Point locFenetre = new Point(fenetre.getX()+50, fenetre.getY()+10);
    Dimension dimFenetre = new Dimension(fenetre.getWidth()-100,
            fenetre.getHeight()-20);
    setLocation(locFenetre);
    setSize(dimFenetre);
    this.parametres = param;
    param.addEventListener(this);
    JButton valideModifs = new JButton(
            new GAction("Valider") {
              @Override
              public void executer() {
                validerModifParametres();
              }
            ;
    });

    JButton annuleModifs = new JButton(
            new GAction("Annuler") {
              @Override
              public void executer() {
                fermerFenetre();
              }
            ;

    });
    Box boutons = Box.createHorizontalBox();
    boutons.add(Box.createGlue());
    boutons.add(valideModifs, Box.CENTER_ALIGNMENT);
    boutons.add(Box.createHorizontalStrut(5));
    boutons.add(annuleModifs, Box.CENTER_ALIGNMENT);
    boutons.add(Box.createGlue());
    add(boutons, BorderLayout.SOUTH);
    JTabbedPane panneauTabule = new JTabbedPane();
//    panneauTabule.addChangeListener(this);
    Box panneauLissagePeriodes = Box.createVerticalBox();
    JPanel pLisPerTexte = new JPanel();
    pLisPerTexte.setBorder(new TitledBorder("Conventions textuelles"));
    panneauLissagePeriodes.add(pLisPerTexte);
    JPanel pLisPerNum = new JPanel();
    pLisPerNum.setBorder(new TitledBorder("Paramètres de calcul"));
    panneauLissagePeriodes.add(pLisPerNum);
    Box panneauProeminences = Box.createVerticalBox();
    JPanel pPromTexte = new JPanel();
    pPromTexte.setBorder(new TitledBorder("Conventions textuelles"));
    panneauProeminences.add(pPromTexte);
    JPanel pPromNum = new JPanel();
    pPromNum.setBorder(new TitledBorder("Paramètres de calcul"));
    panneauProeminences.add(pPromNum);
    JPanel panneauAffichage = new JPanel();
    panneauTabule.add("Stylisations et périodes", panneauLissagePeriodes);
    panneauTabule.add("Proéminences", panneauProeminences);
    panneauTabule.add("Affichage", panneauAffichage);
    pLisPerTexte.add(saisieNomTirePausesPeriodes);
    pLisPerTexte.add(saisieMarquesPausePeriodes);
    pLisPerTexte.add(saisieNomTireEuh);
    pLisPerTexte.add(saisieMarquesEuh);
    pLisPerTexte.add(saisieNomTireLocuteurs);
    pLisPerTexte.add(saisieNomTirePeriodesReference);
    pLisPerTexte.add(saisieNomTirePeriodesCalculees);
    pLisPerTexte.add(saisieNomTireSyllabesProsogrammes);
    pLisPerNum.add(saisieFenetreLissage);
    pLisPerNum.add(saisieEcartMaxLissage);
    pLisPerNum.add(saisieEuhDescendantPeriode);
    pLisPerNum.add(saisieDistanceMaximumPeriode);
    pLisPerNum.add(saisieRegistrePeriode);
    pLisPerNum.add(saisieSeuilPausePeriodes);
    pLisPerNum.add(saisieSeuilGestePeriodes);
    pLisPerNum.add(saisieSeuilSautPeriodes);
    pLisPerNum.add(saisiePoidsPausePeriodes);
    pLisPerNum.add(saisiePoidsGestePeriodes);
    pLisPerNum.add(saisiePoidsSautPeriodes);
    pPromTexte.add(saisieNomTirePhonemes);
    pPromTexte.add(saisieVoyelles);
    pPromTexte.add(saisieNomTireSyllabesProms);
    pPromTexte.add(saisieMarquesPauseProms);
    pPromTexte.add(saisieNomTireDysFluences);
    pPromTexte.add(saisieMarquesDysFluences);
    pPromTexte.add(saisieNomTirePromsReference);
    pPromTexte.add(saisieMarquesPromsReference);
    pPromTexte.add(saisieNomTirePromsCalculees);
    pPromTexte.add(saisieMarquesPromsCalculees);
    pPromTexte.add(saisieNomTirePromsForce);
    pPromNum.add(saisieRestrictionVocalique);
    pPromNum.add(saisiePoidsPhonemes);
    pPromNum.add(saisieEmpans);
    pPromNum.add(saisieCompteSyllabeCentrale);
    pPromNum.add(saisieSeuilDureeProms);
    pPromNum.add(saisieSeuilHauteurProms);
    pPromNum.add(saisieSeuilMonteeProms);
    pPromNum.add(saisiePenteForce);
    pPromNum.add(saisiePoidsForce);
    add(panneauTabule, BorderLayout.CENTER);
    setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);

    addWindowListener(
            new WindowAdapter() {
              @Override
              public void windowClosing(WindowEvent evt) {
                confirmerFermerFenetre();
              }
            });

  }
  private void setValeursParametres() {
    saisieNomTirePausesPeriodes.setValeurNom(parametres.getNomTirePausesPeriodes());
    saisieNomTireEuh.setValeurNom(parametres.getNomTireEuh());
    saisieNomTireLocuteurs.setValeurNom(parametres.getNomTireLocuteurs());
     saisieNomTireSyllabesProsogrammes.setValeurNom(
             parametres.getNomTireSyllabesProsogrammes());
   saisieNomTirePeriodesReference.setValeurNom(parametres.getNomTirePeriodesReference());
   saisieNomTirePeriodesCalculees.setValeurNom(parametres.getNomTirePeriodesCalculees());
    saisieMarquesPausePeriodes.setValeursMarques(parametres.getMarquesPausePeriodes());
    saisieMarquesEuh.setValeursMarques(parametres.getMarquesEuh());
    saisieFenetreLissage.setValeursDurees(parametres.getFenetreLissage());
    saisieEcartMaxLissage.setValeursFrequences(parametres.getEcartmaxLissage());
    saisieEuhDescendantPeriode.setValeursFrequences(parametres.getEuhDescendantPeriodes());
    saisieDistanceMaximumPeriode.setValeursDurees(parametres.getDistanceMaximumPeriodes());
    saisieRegistrePeriode.setValeursFrequences(parametres.getRegistrePeriodes());
    saisieSeuilPausePeriodes.setValeursDurees(
            parametres.getSeuilPausePeriodes());
    saisieSeuilGestePeriodes.setValeursFrequences(parametres.getSeuilGestePeriodes());
    saisieSeuilSautPeriodes.setValeursFrequences(parametres.getSeuilSautPeriodes());
   saisiePoidsPausePeriodes.setValeursRapports(parametres.getPoidsPausePeriodes());
    saisiePoidsGestePeriodes.setValeursRapports(parametres.getPoidsGestePeriodes());
    saisiePoidsSautPeriodes.setValeursRapports(parametres.getPoidsSautPeriodes());
    saisieNomTirePhonemes.setValeurNom(parametres.getNomTirePhonemes());
    saisieNomTireSyllabesProms.setValeurNom(parametres.getNomTireSyllabesProms());
    saisieNomTireDysFluences.setValeurNom(parametres.getNomTireDysFluences());
    saisieNomTirePromsReference.setValeurNom(parametres.getNomTirePromsReference());
    saisieNomTirePromsCalculees.setValeurNom(parametres.getNomTirePromsCalculees());
    saisieNomTirePromsForce.setValeurNom(parametres.getNomTirePromsForce());
    saisieVoyelles.setValeursMarques(parametres.getVoyelles());
    saisieMarquesPauseProms.setValeursMarques(parametres.getMarquesPauseProms());
    saisieMarquesDysFluences.setValeursMarques(parametres.getMarquesDysFluences());
    saisieMarquesPromsReference.setValeursMarques(parametres.getMarquesPromsReference());
    saisieMarquesPromsCalculees.setValeursMarques(new String[]{
              parametres.getMarquePromsFaiblesCalculees(),
              parametres.getMarquePromsFortesCalculees()});
    saisieRestrictionVocalique.setValeurBooleen(parametres.getRestrictionVocalique());
    saisiePoidsPhonemes.setValeursRapports(parametres.getPoidsPhonemes());
    saisieEmpans.setValeursEntiers(parametres.getEmpans());
    saisieCompteSyllabeCentrale.setValeurBooleen(parametres.getCompteSyllabeCentrale());
    saisieSeuilDureeProms.setValeursRapports(parametres.getSeuilDureeProms());
    saisieSeuilHauteurProms.setValeursFrequences(parametres.getSeuilHauteurProms());
    saisieSeuilMonteeProms.setValeursFrequences(parametres.getSeuilMonteeProms());
    saisiePenteForce.setValeursRapports(parametres.getPenteForceDuree(),
            parametres.getPenteForceHauteur(), parametres.getPenteForceMontee());
    saisiePoidsForce.setValeursRapports(parametres.getPoidsForceDuree(),
            parametres.getPoidsForceHauteur(), parametres.getPoidsForceMontee(),
            parametres.getPoidsForcePause());
//

  }
  private void validerModifParametres() {
    Parametres2 param = new Parametres2();
    try {
      param.setNomTirePausesPeriodes(saisieNomTirePausesPeriodes.getValeurNom());
      param.setNomTireEuh(saisieNomTireEuh.getValeurNom());
      param.setNomTireLocuteurs(saisieNomTireLocuteurs.getValeurNom());
      param.setNomTirePeriodesReference(saisieNomTirePeriodesReference.getValeurNom());
     param.setNomTirePeriodesCalculees(saisieNomTirePeriodesCalculees.getValeurNom());
      param.setNomTireSyllabesProsogrammes(saisieNomTireSyllabesProsogrammes.getValeurNom());
      param.setMarquesPausePeriodes(saisieMarquesPausePeriodes.getValeursMarques());
      param.setMarquesEuh(saisieMarquesEuh.getValeursMarques());
      param.setFenetreLissage(saisieFenetreLissage.getValeursDurees(false, 0)[0]);
      param.setEcartmaxLissage(saisieEcartMaxLissage.getValeursFrequences(false, 0)[0]);
      param.setEuhDescendantPeriodes(
              saisieEuhDescendantPeriode.getValeursFrequences(false)[0]);
      param.setDistanceMaximumPeriodes(
              saisieDistanceMaximumPeriode.getValeursDurees(false, 0)[0]);
      param.setRegistrePeriodes(saisieRegistrePeriode.getValeursFrequences(false, 0)[0]);
      param.setSeuilPausePeriodes(
              saisieSeuilPausePeriodes.getValeursDurees(false, 0)[0]);
      param.setSeuilGestePeriodes(
              saisieSeuilGestePeriodes.getValeursFrequences(false, 0)[0]);
      param.setSeuilSautPeriodes(
              saisieSeuilSautPeriodes.getValeursFrequences(false, 0)[0]);
      param.setPoidsPausePeriodes(
              saisiePoidsPausePeriodes.getValeursRapports(false, 0)[0]);
      param.setPoidsGestePeriodes(
              saisiePoidsGestePeriodes.getValeursRapports(false, 0)[0]);
      param.setPoidsSautPeriodes(
              saisiePoidsSautPeriodes.getValeursRapports(false, 0)[0]);
      param.setNomTirePhonemes(saisieNomTirePhonemes.getValeurNom());
      param.setNomTireSyllabesProms(saisieNomTireSyllabesProms.getValeurNom());
      param.setNomTireDysFluences(saisieNomTireDysFluences.getValeurNom());
      param.setNomTirePromsReference(saisieNomTirePromsReference.getValeurNom());
      param.setNomTirePromsCalculees(saisieNomTirePromsCalculees.getValeurNom());
      param.setNomTirePromsForce(saisieNomTirePromsForce.getValeurNom());
      param.setVoyelles(saisieVoyelles.getValeursMarques());
      param.setMarquesPauseProms(saisieMarquesPauseProms.getValeursMarques());
      param.setMarquesDysFluences(saisieMarquesDysFluences.getValeursMarques());
      param.setMarquesPromsReference(saisieMarquesPromsReference.getValeursMarques());
      String[] marques = saisieMarquesPromsCalculees.getValeursMarques();
      param.setMarquePromsFortesCalculees(marques[1]);
      param.setMarquePromsFaiblesCalculees(marques[0]);
      param.setRestrictionVocalique(saisieRestrictionVocalique.getValeurBooleen());
      param.setPoidsPhonemes(saisiePoidsPhonemes.getValeursRapports(false, 0, 1)[0]);
      param.setEmpans(saisieEmpans.getValeursEntiers(false, 0));
      param.setCompteSyllabeCentrale(saisieCompteSyllabeCentrale.getValeurBooleen());
      param.setSeuilDureeProms(saisieSeuilDureeProms.getValeursRapports(false, 0)[0]);
      param.setSeuilHauteurProms(saisieSeuilHauteurProms.getValeursFrequences(false, 0)[0]);
      param.setSeuilMonteeProms(saisieSeuilMonteeProms.getValeursFrequences(false, 0)[0]);
      double[] pentes = saisiePenteForce.getValeursRapports(false, 0);
      param.setPenteForceDuree(pentes[0]);
      param.setPenteForceHauteur(pentes[1]);
      param.setPenteForceMontee(pentes[2]);
      double[] poids = saisiePoidsForce.getValeursRapports(false, 0);
      param.setPoidsForceDuree(poids[0]);
      param.setPoidsForceHauteur(poids[1]);
      param.setPoidsForceMontee(poids[2]);
      param.setPoidsForcePause(poids[3]);
    } catch (NumberFormatException ex) {
      GMessages.impossibiliteAction(ex.getMessage());
      return;
    }
    parametres.setParametresSaisis(param);
    fermerFenetre();
  }
  private void fermerFenetre() {
    setVisible(false);
    setModalityType(ModalityType.MODELESS);
  }
  private void confirmerFermerFenetre() {
    try {
      if (getModalityType().equals(ModalityType.MODELESS)) {
        fermerFenetre();
        return;
      }
      int rep = JOptionPane.showOptionDialog(this, "Valider les modifications ?",
              "Fermeture de la fenêtre \"Gestion des paramètres\"",
              JOptionPane.DEFAULT_OPTION, JOptionPane.QUESTION_MESSAGE,
              null, new Object[]{"Oui", "Non", "Annuler"}, "Non");
      if (rep==2) return;
      if (rep==0) validerModifParametres();
      else fermerFenetre();
    } catch (Throwable ex) {
      GMessages.erreurFatale(ex);
    }
  }
  @Override
  public void traiterEventParametres(MessageParametres evt) {
    setVisible(false);
  }
  @Override
  public void actionPerformed(ActionEvent evt) {
    if (getModalityType().equals(ModalityType.MODELESS)) {
      setVisible(false);
      setModalityType(ModalityType.APPLICATION_MODAL);
      setVisible(true);
    }
  }

  private static class SaisieParametre extends JPanel {
    private JTextField[] champsSaisie;
    private String nom;
    private SaisieParametre(ActionListener fen, int nbparam, String nom,
            String... lignesTitre) {
      super();
      this.nom = nom;
      Box box = Box.createVerticalBox();
      Box boxTitre = Box.createHorizontalBox();
      boxTitre.add(Box.createHorizontalGlue());
      boxTitre.add(new JLabel(GVisu.styleNomChamp(lignesTitre)));
      boxTitre.add(Box.createHorizontalGlue());
      box.add(boxTitre);
      box.add(Box.createVerticalStrut(5));
      Box boxSaisie = Box.createHorizontalBox();
      boxSaisie.add(Box.createHorizontalGlue());
      champsSaisie = new JTextField[nbparam];
      for (int i = 0; i<nbparam; i++) {
        champsSaisie[i] = new JTextField();
        champsSaisie[i].addActionListener(fen);
        //       champsSaisie[i].setColumns(nbcar);
        champsSaisie[i].setHorizontalAlignment(JTextField.CENTER);
        boxSaisie.add(Box.createHorizontalStrut(3));
        boxSaisie.add(champsSaisie[i]);
        boxSaisie.add(Box.createHorizontalStrut(3));
      }
      boxSaisie.add(Box.createHorizontalGlue());
      box.add(boxSaisie);
      add(box);
    }
    private void setValeurNom(String val) {
      champsSaisie[0].setText(val);
    }
    private void setValeursMarques(String[] val) {
      String valeur = "";
      if (val.length>0) {
        valeur = val[0];
        for (int i = 1; i<val.length; i++) valeur += ";"+val[i];
      }
      champsSaisie[0].setText(valeur);
    }
    private void setValeursDurees(double... val) {
      for (int i = 0; i<val.length; i++) {
        float valeur = Math.round((float) val[i]*1000)/1000f;
        champsSaisie[i].setText(Float.toString(valeur));
      }
    }
    private void setValeursFrequences(double... val) {
      for (int i = 0; i<val.length; i++) {
        float valeur = Math.round((float) val[i]*12*100)/100f;
        champsSaisie[i].setText(Float.toString(valeur));
      }
    }
    private void setValeursRapports(double... val) {
      for (int i = 0; i<val.length; i++) {
        float valeur = Math.round((float) val[i]*100)/100f;
        champsSaisie[i].setText(Float.toString(valeur));
      }
    }
    private void setValeursEntiers(int... val) {
      for (int i = 0; i<val.length; i++) {
        champsSaisie[i].setText(Integer.toString(val[i]));
      }
    }
    private void setValeurBooleen(boolean rep) {
      champsSaisie[0].setText(rep ? "oui" : "non");
    }
    private String getValeurNom() {
      return champsSaisie[0].getText().trim();
    }
    private String[] getValeursMarques() {
      String[] marques = champsSaisie[0].getText().split(";");
      int nbvides = 0;
      for (int i = 0; i<marques.length; i++) {
        marques[i] = marques[i].trim();
        if (marques[i].isEmpty()) nbvides++;
      }
      if (nbvides==0) return marques;
      String[] marques1 = new String[marques.length-nbvides];
      int i = 0;
      for (String m : marques) if (!m.isEmpty()) marques1[i++] = m;
      return marques1;
    }
    private double[] getValeursDurees( boolean croissant, double... minmax) {
      double[] vals = new double[champsSaisie.length];
      try {
        for (int i = 0; i<champsSaisie.length; i++) {
          vals[i] = Double.valueOf(champsSaisie[i].getText());
          vals[i] = Math.round((float) vals[i]*1000)/1000f;
          if(minmax.length>0&&vals[i]<minmax[0]) throw new NumberFormatException();
          if(minmax.length>1&&vals[i]>minmax[1]) throw new NumberFormatException();
          if(croissant&&i>0&&vals[i]<vals[i-1]) throw new NumberFormatException();
        }
      } catch (NumberFormatException ex) {
        throw new NumberFormatException("Format invalide pour le paramètre \""
                +nom+"\"");
      }
      return vals;
    }
    private double[] getValeursFrequences(boolean croissant, double... minmax) {
      double[] vals = new double[champsSaisie.length];
      try {
        for (int i = 0; i<champsSaisie.length; i++) {
          vals[i] = Double.valueOf(champsSaisie[i].getText());
          vals[i] = Math.round((float) vals[i]*100)/(12*100f);
          if(minmax.length>0&&vals[i]<minmax[0]) throw new NumberFormatException();
          if(minmax.length>1&&vals[i]>minmax[1]) throw new NumberFormatException();
         if(croissant&&i>0&&vals[i]<vals[i-1]) throw new NumberFormatException();
        }
      } catch (NumberFormatException ex) {
        throw new NumberFormatException("Format invalide pour le paramètre \""
                +nom+"\"");
      }
      return vals;
    }
    private double[] getValeursRapports(boolean croissant, double... minmax) {
      double[] vals = new double[champsSaisie.length];
      try {
        for (int i = 0; i<champsSaisie.length; i++) {
          vals[i] = Double.valueOf(champsSaisie[i].getText());
          vals[i] = Math.round((float) vals[i]*100)/100f;
         if(minmax.length>0&&vals[i]<minmax[0]) throw new NumberFormatException();
          if(minmax.length>1&&vals[i]>minmax[1]) throw new NumberFormatException();
          if(croissant&&i>0&&vals[i]<vals[i-1]) throw new NumberFormatException();
        }
      } catch (NumberFormatException ex) {
        throw new NumberFormatException("Format invalide pour le paramètre \""
                +nom+"\"");
      }
      return vals;
    }
    private int[] getValeursEntiers(boolean croissant, int... minmax) {
      int[] vals = new int[champsSaisie.length];
      try {
        for (int i = 0; i<champsSaisie.length; i++) {
          vals[i] = Integer.valueOf(champsSaisie[i].getText());
         if(minmax.length>0&&vals[i]<minmax[0]) throw new NumberFormatException();
          if(minmax.length>1&&vals[i]>minmax[1]) throw new NumberFormatException();
          if(croissant&&i>0&&vals[i]<vals[i-1]) throw new NumberFormatException();
       }
      } catch (NumberFormatException ex) {
        throw new NumberFormatException("Format invalide pour le paramètre \""
                +nom+"\"");
      }
      return vals;
    }
    private boolean getValeurBooleen() {
      String rep = champsSaisie[0].getText().trim();
      if ("oui".equals(rep)) return true;
      if ("non".equals(rep)) return false;
      throw new NumberFormatException("Format invalide pour le paramètre \""
              +nom+"\" : répondre \"oui\" ou \"non\"");
    }
  }
}
